import("pathfinder.road", "RoadPF", 4);

class CivilAI extends AIController
{
  function Save();
  function Load(version, data);
  function Start();
  function LoadParas();
  function LocateHomeTown();
  function SetName(HomeTownName);
  function BuildHQ();
  function BuildHomeDepot(hq,hometown);
  function FindHomeDepot();
	
  function BuildDepot(roadtile,town); 
  function IdentifyBus(silent);
  function IdentifyCoach(silent);
  function BuildBuses(town,depot);
  function BuildBusStop(xoff,yoff,count,spread,town,rem,spike);
  function SpikeX(tile,town);
  function SpikeY(tile,town);
  function InterCity();
  function CreateRoute(vehicle,count,stops,depot,routename,fullload);
  function NewNetwork();
  function NewDepot();
  
  function Failure();   
  function MainLoop();
  
  function CashUp();
  function CashDown();
  
  function BusReview();
  function DepotClean();
  function HomeConnect();
  
  function MappaMundi();
  function BuildARoad(a,b,target);
  
  function Vroom();
  function Airportz();  
  function BuildAirport(station,location);
  function BuildSmAp(station,location);
  function BuildComAp(station,location);
  function AirReview();
  function AirAssign(station);
  
  function MyTownList();
  function RoadWork();
  function XingReplace();
  function XingReplace2();
  
  function MakeGroups();
  function LoadGroups();
  Groups = [0,0];
  
  HomeDepot = 0;
  IsLoaded = false;
  Dudtowns = AIList();
  NetworkRadius = null;
  MinPop = null;
  MaxBus = null;
  MaxCar = null;
  BuyCar = null;
  MinAirRange = null;
  BuyPlane = null;
  
  XinglistX =  AIList();
  XinglistY =  AIList(); 
  
  Me = (AICompany.ResolveCompanyID(AICompany.COMPANY_SELF));
}
//>
// ====================================================== 
//                       SAVE/LOAD
// ====================================================== 

function CivilAI::Save() {
local Save = {};
return Save;
}  
function CivilAI::Load(version, data) {
IsLoaded = true;
}  


// ====================================================== 
//                     LOAD PARAMETERS
// ====================================================== 

function CivilAI::LoadParas() {
NetworkRadius = AIController.GetSetting("NetworkRadius");
MinPop = AIController.GetSetting("MinPop");
MaxBus = AIController.GetSetting("MaxBus");
MaxCar = AIController.GetSetting("MaxCar");
BuyCar = (AIController.GetSetting("BuyCar") / 2);
MinAirRange = (AIController.GetSetting("MinAirRange"));
BuyPlane = (AIController.GetSetting("BuyPlane"));
}
  
// ====================================================== 
//                         START
// ====================================================== 
  
function CivilAI::Start()
{

// Startup parameters:
AIRoad.SetCurrentRoadType(AIRoad.ROADTYPE_ROAD);
AICompany.SetAutoRenewStatus(false); // we don't do autorenew

LoadParas();

if (!IsLoaded) {
MakeGroups();
LocateHomeTown();
} else {
LoadGroups();
}

MainLoop();

while (1){
AILog.Info("Never should've come here!");
AIController.Sleep(600);
}
}

// ====================================================== 
//                     COMPANY FAIL
// ====================================================== 

function CivilAI::Failure()
{
AILog.Info("Woe is me!")
AICompany.SetName("Failed CivilAI");
CashDown();
while (1) {
AIController.Sleep(1000000);
}
}

// ====================================================== 
//                      MAIN LOOP
// ====================================================== 

function CivilAI::MainLoop() 
{

if (IsLoaded) {
AILog.Info("Welcome back!");
FindHomeDepot();
} else {
CashDown();
AILog.Info("Now that I have introduced myself, I should like to have some idea of what is going on...");
}
while (true) {

AILog.Info("Recycling...");												
BusReview();																//JAN - Bus Review
MappaMundi();																//FEB - Roads
RoadWork();																	//MAR - Town Stuff
DepotClean();																//APR - Clear Depots
HomeConnect();																//MAY - Check Home Depot
XingReplace2();																// - replace level xings
XingReplace();																// - replace level xings
LoadParas();
Vroom();																	//JUN - Town Cars
Airportz();
BusReview();																//JUL - Bus Review
MappaMundi();																//AUG - Roads
RoadWork();																	//SEP - Town Stuff
NewNetwork();																//OCT - New Bus Network
InterCity();																//NOV - Intercity
XingReplace2();																// - replace level xings
XingReplace();																// - replace level xings
LoadParas();
Vroom();																	//DEC - Town Cars
AirReview();
}
}

// ====================================================== 
//                    LOAN MANAGEMENT
// ====================================================== 

function CivilAI::CashUp() {

AICompany.SetLoanAmount(AICompany.GetMaxLoanAmount());
//AILog.Info("I've borrowed some money from the bank.")
return
}

function CivilAI::CashDown() {


local bollox = 0; // just in case
while ((AICompany.GetBankBalance(Me) > AICompany.GetLoanInterval()) && bollox < 100) {
AICompany.SetLoanAmount(AICompany.GetLoanAmount()-AICompany.GetLoanInterval())
bollox++
}

//AILog.Info("I've paid off as much of my loan as I can.")
return
}


// ====================================================== 
//                   HOME TOWN SET UP
// ====================================================== 

function CivilAI::LocateHomeTown()
{
AILog.Info("Oh, hello...");

// find a town
local bigtown = null;
local townlist = AITownList();
townlist.Valuate(AITown.GetPopulation);
townlist.RemoveBelowValue(MinPop);

// remove unreachables
foreach (town,z in townlist) {
local towntile = AITown.GetLocation(town);
if (!AITile.HasTransportType(towntile,AITile.TRANSPORT_ROAD)) {
AILog.Info(AITown.GetName(town) + " has no central road tile.");
townlist.RemoveItem(town);
} else {
}
}

townlist.Valuate(AIBase.RandItem); // shuffle the list

foreach (town,z in townlist) {
if (!((AITown.GetLastMonthSupplied(town, 0) * 15) > AITown.GetPopulation(town))) {
bigtown = town;
break;
}
}
	
if (bigtown == null) {	
AILog.Info("I couldn't find a town to set up in.");	
Failure();	
}	

//AILog.Info("First, I should probably name the company, and myself...");	
SetName(AITown.GetName(bigtown));
AILog.Info("I'll set up my headquarters in " + (AITown.GetName(bigtown)) + ".");	
BuildHQ(bigtown);
return
}

function CivilAI::SetName(HomeTownName)
{
local companynames = [0,1,2,3,4,5,6,7]

companynames[0] = (HomeTownName + " Garages");
companynames[1] = ("Transport for " + HomeTownName);
companynames[2] = (HomeTownName + " Engineering");
companynames[3] = (HomeTownName + " Public Works");

AICompany.SetPresidentName("The Engineer");
if (!AICompany.SetName(companynames[AIBase.RandRange(4)]))
{
AICompany.SetName("CivilAI & Co.");
}



return
}

// ====================================================== 
//                     BUILD HQ
// ====================================================== 

function CivilAI::BuildHQ(hometown)
{
// Let's (in)elegantly brute-force the HQ!

  local HomeTownGrid = [0,0];
  local HQ = 0;

local towntile = AITown.GetLocation(hometown);
HomeTownGrid[0] = AIMap.GetTileX(towntile);
HomeTownGrid[1] = AIMap.GetTileY(towntile);

local trytilegrid = [0,0]
local trytile = AIMap.GetTileIndex(trytilegrid[0],trytilegrid[1]);

// this is a cross search!

local i = 0; // iteration
local s = 3; // initial cross length
local j = AIBase.RandRange(2); // toggle x/y
local k = AIBase.RandRange(4); // toggle +/-

while (!AICompany.BuildCompanyHQ(trytile)) {

if (j == 0) {
	trytilegrid[1] = HomeTownGrid[1] + 2;
	if (k < 2) {
	trytilegrid[0] = (HomeTownGrid[0] + s);	
	} else {
    trytilegrid[0] = (HomeTownGrid[0] - s);
	}
} else {
	trytilegrid[0] = HomeTownGrid[0] + 2;
	if (k < 2) {
	trytilegrid[1] = (HomeTownGrid[1] + s);	
	} else {
    trytilegrid[1] = (HomeTownGrid[1] - s);	
	}
}

trytile = AIMap.GetTileIndex(trytilegrid[0],trytilegrid[1]);
// AISign.BuildSign(trytile, "I tried to build an HQ here");

if (j < 1) {
		j = j + 1;
		} else {
		j = 0;
		}
if (k < 3) {
		k = k + 1;
		} else {
		k = 0;
		}
if (i < 3) {
		i = i + 1;
		} else {
		i = 0;
		s = s + 5;
		}		

}
HQ = trytile;
AILog.Info("I've built an HQ at " + trytilegrid[0] + " ," + trytilegrid[1] + ". We're off to a good start!");	


BuildHomeDepot(HQ,hometown);
BuildBuses(hometown,HomeDepot);
return
}

// ====================================================== 
//                 PLACE HOME DEPOT
// ====================================================== 

function CivilAI::BuildHomeDepot(hq,hometown)
{
AILog.Info("I'll build my first depot as close to the HQ as possible.")


// clockwise spiral out
local trytilegrid = [AIMap.GetTileX(hq),AIMap.GetTileY(hq)]
local trytile;
local x = 1
local y = 1
local i = 0
while ((HomeDepot == 0) && (i < 20)) {
//y--
for (;y >= 0-i;y--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, "?");
//AILog.Info("testing tile at " + x + "," + y);
if (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD) 
&& !AIRoad.IsRoadDepotTile(trytile)
&& !AIRoad.IsRoadStationTile(trytile)
&& !AIRoad.IsDriveThroughRoadStationTile(trytile)
&& !AIBridge.IsBridgeTile(trytile)
&& !HomeDepot)
HomeDepot = BuildDepot(trytile,hometown);
}
//x--;
for (;x >= 0-i;x--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, "?");
//AILog.Info("testing tile at " + x + "," + y);
if (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD) 
&& !AIRoad.IsRoadDepotTile(trytile)
&& !AIRoad.IsRoadStationTile(trytile)
&& !AIRoad.IsDriveThroughRoadStationTile(trytile)
&& !AIBridge.IsBridgeTile(trytile)
&& !HomeDepot)
HomeDepot = BuildDepot(trytile,hometown);
}
//y++;
for (;y <= i;y++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, "?");
//AILog.Info("testing tile at " + x + "," + y);
if (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD)
&& !AIRoad.IsRoadDepotTile(trytile)
&& !AIRoad.IsRoadStationTile(trytile)
&& !AIRoad.IsDriveThroughRoadStationTile(trytile)
&& !AIBridge.IsBridgeTile(trytile)
&& !HomeDepot)
HomeDepot = BuildDepot(trytile,hometown);
}
//x++;
for (;x <= i;x++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, "?");
//AILog.Info("testing tile at " + x + "," + y);
if (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD)
&& !AIRoad.IsRoadDepotTile(trytile)
&& !AIRoad.IsRoadStationTile(trytile)
&& !AIRoad.IsDriveThroughRoadStationTile(trytile)
&& !AIBridge.IsBridgeTile(trytile)
&& !HomeDepot)
HomeDepot = BuildDepot(trytile,hometown);
}
i=i+1
}

if (HomeDepot) {
AILog.Info("I've built my home depot at " + AIMap.GetTileX(HomeDepot) + "," + AIMap.GetTileY(HomeDepot) + "."); 
} else {
AILog.Info("I've failed to build a depot."); 
Failure();
}
return
}

// ====================================================== 
//             FIND HOME DEPOT (after load)
// ====================================================== 


function CivilAI::FindHomeDepot()
{
local hq = AICompany.GetCompanyHQ(Me);
if (hq != -1) {

AILog.Info("I'm looking for my home depot. It should be near my headquarters in " + AITown.GetName(AITile.GetClosestTown(hq)) + ".")

// clockwise spiral out
local trytilegrid = [AIMap.GetTileX(hq),AIMap.GetTileY(hq)]
local trytile;
local x = 1
local y = 1
local i = 0
while ((HomeDepot == 0) && (i < 20)) {
//y--
for (;y >= 0-i;y--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);

if (AIRoad.IsRoadDepotTile(trytile)
	&& AICompany.IsMine(AITile.GetOwner(trytile))
	&& !HomeDepot)
	{
	HomeDepot = trytile;
	}
}
//x--;
for (;x >= 0-i;x--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);


if (AIRoad.IsRoadDepotTile(trytile) 
	&& AICompany.IsMine(AITile.GetOwner(trytile))
	&& !HomeDepot)
	{
	HomeDepot = trytile;
	}
}
//y++;
for (;y <= i;y++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);

if (AIRoad.IsRoadDepotTile(trytile)
	&& AICompany.IsMine(AITile.GetOwner(trytile))
	&& !HomeDepot)
	{
	HomeDepot = trytile;
	}
}
//x++;
for (;x <= i;x++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);

if (AIRoad.IsRoadDepotTile(trytile)  
	&& AICompany.IsMine(AITile.GetOwner(trytile))
	&& !HomeDepot)
	{
	HomeDepot = trytile;
	}
}
i=i+1
}

if (HomeDepot) {
AILog.Info("I've found my home depot at " + AIMap.GetTileX(HomeDepot) + "," + AIMap.GetTileY(HomeDepot) + ".") 

if (AICompany.GetName(Me) == "Failed CivilAI") { SetName(AITown.GetName(AITile.GetClosestTown(hq))) } // resurrect formerly failed AI.

} else {
AILog.Info("I can't find my home depot."); 
Failure();
}
} else {
AILog.Info("I can't find my headquarters."); 
Failure();
}
return
}
// ====================================================== 
//            CHECK HOME DEPOT IS CONNECTED
// ====================================================== 
function CivilAI::HomeConnect() {

AILog.Info("I'm checking my home depot is still connected to the road network.");
CashUp();

// check all our depots are connected to the tile in front of them
local dlist = AIDepotList(AITile.TRANSPORT_ROAD); 	
foreach (depot, z in dlist) {
AIRoad.BuildRoad (AIRoad.GetRoadDepotFrontTile(depot),depot);
//AILog.Info("Checking immediate connection at depot " + depot)
}


local hq = AICompany.GetCompanyHQ(Me);
local a = [AIRoad.GetRoadDepotFrontTile(HomeDepot)]
local b = [AITown.GetLocation(AITile.GetClosestTown(hq))]

local buildroad = RoadPF();
buildroad.cost.max_cost 			= 10000000;   //10000000;
buildroad.cost.tile     			= 100;        // 100;
buildroad.cost.no_existing_road		= 75;         //40;
buildroad.cost.turn           		= 100;        //100;
buildroad.cost.slope          		= 400;        //200;
buildroad.cost.bridge_per_tile		= 500;        //150;
buildroad.cost.tunnel_per_tile		= 900;        //120;
buildroad.cost.coast       			= 100;        //20;
buildroad.cost.max_bridge_length	= 10;          //10;
buildroad.cost.max_tunnel_length	= 20;          //20;

buildroad.InitializePath(a, b);

local path = false;
while (path == false) {
  path = buildroad.FindPath(50);
  AIController.Sleep(3);
}


if (path == null) {
AILog.Info("It isn't.")
Failure();
return
}
while (path != null) {
  local par = path.GetParent();
  if (par != null) {
    local last_node = path.GetTile();
    if (AIMap.DistanceManhattan(path.GetTile(), par.GetTile()) == 1 ) {
      if (!AIRoad.BuildRoad(path.GetTile(), par.GetTile())) {
        /* An error occurred while building a piece of road. TODO: handle it. 
         * Note that this could mean the road was already built. */
      }
    } else {
      /* Build a bridge or tunnel. */
      if (!AIBridge.IsBridgeTile(path.GetTile()) && !AITunnel.IsTunnelTile(path.GetTile())) {
        /* If it was a road tile, demolish it first. Do this to work around expended roadbits. */
        if (AIRoad.IsRoadTile(path.GetTile())) AITile.DemolishTile(path.GetTile());
        if (AITunnel.GetOtherTunnelEnd(path.GetTile()) == par.GetTile()) {
          if (!AITunnel.BuildTunnel(AIVehicle.VT_ROAD, path.GetTile())) {
            /* An error occured while building a tunnel. TODO: handle it. */
          }
        } else {
          local bridge_list = AIBridgeList_Length(AIMap.DistanceManhattan(path.GetTile(), par.GetTile()) + 1);
          bridge_list.Valuate(AIBridge.GetMaxSpeed);
          bridge_list.Sort(AIList.SORT_BY_VALUE, false);
          if (!AIBridge.BuildBridge(AIVehicle.VT_ROAD, bridge_list.Begin(), path.GetTile(), par.GetTile())) {
            /* An error occured while building a bridge. TODO: handle it. */
          }
        }
      }
    }
  }
  path = par;
}
AILog.Info("It's fine.")
CashDown();
}

// ====================================================== 
//                    BUILD DEPOT
// ====================================================== 



function CivilAI::BuildDepot(roadtile,town) {
// this is road, check it's joined to the centre of town
local testroad = RoadPF();
local towntile = AITown.GetLocation(town);
local depot = 0;

testroad.cost.no_existing_road = testroad.cost.max_cost; // only check existing roads
testroad.InitializePath([roadtile], [towntile]);

local path = false;
while (path == false) {
path = testroad.FindPath(20);
AIController.Sleep(2);
}

if ((path != null) && (AITile.GetSlope(roadtile) == 0)) { 
// AISign.BuildSign(roadtile, "?");

local builtlink = false; // keep trying if a vehicle is preventing building the road connection
local c = 0;
local roadtilegrid = [AIMap.GetTileX(roadtile),AIMap.GetTileY(roadtile)]
    if (AIRoad.BuildRoadDepot (AIMap.GetTileIndex(roadtilegrid[0]+1,roadtilegrid[1]),roadtile)) {
	depot = AIMap.GetTileIndex(roadtilegrid[0]+1,roadtilegrid[1]);
    while (!builtlink && c < 100) {
	builtlink = AIRoad.BuildRoad (roadtile,depot);
	c++
	AIController.Sleep(5);
	}	
	} else if (AIRoad.BuildRoadDepot (AIMap.GetTileIndex(roadtilegrid[0]-1,roadtilegrid[1]),roadtile)) {
	depot = AIMap.GetTileIndex(roadtilegrid[0]-1,roadtilegrid[1]);
    while (!builtlink && c < 100) {
	builtlink = AIRoad.BuildRoad (roadtile,depot);
	c++
	AIController.Sleep(5);
	}	
	} else if (AIRoad.BuildRoadDepot (AIMap.GetTileIndex(roadtilegrid[0],roadtilegrid[1]+1),roadtile)) {
	depot = AIMap.GetTileIndex(roadtilegrid[0],roadtilegrid[1]+1);	 
    while (!builtlink && c < 100) {
	builtlink = AIRoad.BuildRoad (roadtile,depot);
	c++
	AIController.Sleep(5);
	}	
	} else if (AIRoad.BuildRoadDepot (AIMap.GetTileIndex(roadtilegrid[0],roadtilegrid[1]-1),roadtile)) {
	depot = AIMap.GetTileIndex(roadtilegrid[0],roadtilegrid[1]-1);
    while (!builtlink && c < 100) {
	builtlink = AIRoad.BuildRoad (roadtile,depot);
	c++
	AIController.Sleep(5);
	}	
	}	
}
return depot;
}


//<
// ====================================================== 
// ====================================================== 
//      		   BBBB     U    U    SSSS
//     			   B   BB   U    U   SS   S
//      		   BBBBB    U    U     SS
//       		   B   BB   U    U   S   SS
//       		   BBBB      UUUU     SSSS
// ====================================================== 
// ====================================================== 
//>
// ====================================================== 
//                     BUILD BUS ROUTE
// ====================================================== 

function CivilAI::BuildBuses(town,depot) {
AILog.Info("I'm going to provide local bus services in " + AITown.GetName(town) + "."); 

local HasBus;
local statc;
local statn;
local state;
local statw;
local stats;

local statcount = 0;
local route1;
local route2;

// check if we have buses

HasBus = IdentifyBus(false);
if (!HasBus) {
return
}

// build central bus stop

statc = BuildBusStop (0,0,4,3,town,false,false);

if (!statc) { 
AILog.Info("I've failed to build a central bus stop in " + AITown.GetName(town) + ". Better luck next year, perhaps."); 
if (depot != HomeDepot) (AIRoad.RemoveRoadDepot(depot));

return
} else {
AILog.Info("I've built a central bus stop: " + AIBaseStation.GetName(statc-1) + "."); 
}


// build outer bus stops

statn = BuildBusStop (-10,0,1,5,town,false,true);

if (!statn) { 
//AILog.Info("I've failed to build a northern bus stop in " + AITown.GetName(town) + "."); 
} else {
AILog.Info("I've built a northern bus stop: " + AIBaseStation.GetName(statn-1) + "."); 
statcount++
}


state = BuildBusStop (0,10,1,5,town,false,true);

if (!state) { 
//AILog.Info("I've failed to build an eastern bus stop in " + AITown.GetName(town) + "."); 
} else {
AILog.Info("I've built an eastern bus stop: " + AIBaseStation.GetName(state-1) + "."); 
statcount++
}

stats = BuildBusStop (10,0,1,5,town,false,true);

if (!stats) { 
//AILog.Info("I've failed to build a southern bus stop in " + AITown.GetName(town) + "."); 
} else {
AILog.Info("I've built a southern bus stop: " + AIBaseStation.GetName(stats-1) + "."); 
statcount++
}

statw = BuildBusStop (0,-10,1,5,town,false,true);

if (!statw) { 
//AILog.Info("I've failed to build a western bus stop in " + AITown.GetName(town) + "."); 
} else {
AILog.Info("I've built a western bus stop: " + AIBaseStation.GetName(statw-1) + "."); 
statcount++
}

// okay, let's see what we've got here; time to construct some routes!

if (statcount == 4) {

AILog.Info("I've built five bus stops in " + AITown.GetName(town) + " - great!"); 

CreateRoute(HasBus,2,[statn,statc,stats,statc],depot,(AITown.GetName(town)),false);
CreateRoute(HasBus,2,[statw,statc,state,statc],depot,(AITown.GetName(town)),false);

} else if (statcount == 3) {

AILog.Info("Four stops, that's nice."); 

//identify the missing stop and do routes
if (!statn) {
CreateRoute(HasBus,3,[state,statc,statw,statc,stats,statc],depot,(AITown.GetName(town)),false);
} else if (!state) {
CreateRoute(HasBus,3,[statn,statc,statw,statc,stats,statc],depot,(AITown.GetName(town)),false);
} else if (!statw) {
CreateRoute(HasBus,3,[statn,statc,state,statc,stats,statc],depot,(AITown.GetName(town)),false);
} else {
CreateRoute(HasBus,3,[state,statc,statw,statc,statn,statc],depot,(AITown.GetName(town)),false);
}

} else if (statcount == 2) {

AILog.Info("I can make a route out of these three stops."); 

if (!statn && !state) {
CreateRoute(HasBus,2,[statw,statc,stats,statc],depot,(AITown.GetName(town)),false);
} else if (!statn && !statw) {
CreateRoute(HasBus,2,[stats,statc,state,statc],depot,(AITown.GetName(town)),false);
} else if (!statn && !stats) {
CreateRoute(HasBus,2,[statw,statc,state,statc],depot,(AITown.GetName(town)),false);
} else if (!state && !statw) {
CreateRoute(HasBus,2,[statn,statc,stats,statc],depot,(AITown.GetName(town)),false);
} else if (!state && !stats) {
CreateRoute(HasBus,2,[statw,statc,statn,statc],depot,(AITown.GetName(town)),false);
} else if (!statw && !stats) {
CreateRoute(HasBus,2,[state,statc,statn,statc],depot,(AITown.GetName(town)),false);

}

} else {
AILog.Info("I couldn't build enough bus stops in " + AITown.GetName(town) + ". Better luck next year, perhaps.");
//if (depot != HomeDepot) (AIRoad.RemoveRoadDepot(depot)); // don't remove depots now, we're keeping them for towncars.
}
}

// ====================================================== 
//                  BUY INTERCITY BUS
// ====================================================== 

function CivilAI::InterCity() {

local dosh = ((AICompany.GetMaxLoanAmount() - AICompany.GetLoanAmount()) + AICompany.GetBankBalance(Me));
local nbus = IdentifyCoach(true);

if (nbus == false) {
return;
}
else if (dosh > (AIEngine.GetPrice(nbus-1) * 5)) {

// check we don't have MaxBus
local rvlist = AIVehicleList();
foreach (veh,z in rvlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_ROAD) {
rvlist.RemoveItem(veh);
}
}
rvlist.Valuate(AIVehicle.GetCapacity, 0);
rvlist.KeepAboveValue(9);
local buscount = rvlist.Count();
if (buscount < MaxBus) {

local HasBus = IdentifyCoach(false);
if (!HasBus) {
return
}
AILog.Info("I'm looking for an intercity bus route.");

local bslist = AIStationList(AIStation.STATION_BUS_STOP); 
bslist.Valuate(AIStation.GetCargoWaiting, 0); //order by pax waiting
bslist.RemoveBelowValue(100);
bslist.Valuate(AIBase.RandItem); // shuffle the list

foreach (stop,z in bslist) {
local vlist = AIVehicleList_Station(stop);
foreach (veh,z in vlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_ROAD) {
vlist.RemoveItem(veh);
}
}
if (vlist.Count() > 15) {					// remove saturated stops
//AILog.Info(AIBaseStation.GetName(stop) + " has too many buses already.");
bslist.RemoveItem(stop);
}
}
if (bslist.Count() < 2) {
AILog.Info("I couldn't find one.");
return
}
local stat1 = bslist.Begin();
local stat2 = null;
bslist.RemoveTop(1);
foreach (stop,z in bslist) {
if ((AIStation.GetNearestTown(stop)) != (AIStation.GetNearestTown(stat1))) {
stat2 = stop
break;
}
}
if (stat2 == null) {
AILog.Info("I couldn't find one.");
return
}
local paxo = (((AIStation.GetCargoWaiting(stat1,0) + AIStation.GetCargoWaiting(stat2,0)) / 1000 ) + 1)
CashUp();

if (paxo == 1){ 
AILog.Info("I'm buying " + paxo + " bus to run from " + (AIBaseStation.GetName(stat1)) + " to " + (AIBaseStation.GetName(stat2)) + ".");
} else {
AILog.Info("I'm buying " + paxo + " buses to run from " + (AIBaseStation.GetName(stat1)) + " to " + (AIBaseStation.GetName(stat2)) + ".");
}

CreateRoute(HasBus,paxo,[stat1+1,stat2+1],HomeDepot,(AITown.GetName(AIStation.GetNearestTown(stat1))),false);

} else {
AILog.Info("I've already got my maximum number of buses, so I won't build more.")
}
} else {
AILog.Info("I don't have the money for new buses at the moment.")
}

CashDown();
return
}


// ====================================================== 
//                BUILD/REMOVE BUS STOP
// ====================================================== 

function CivilAI::BuildBusStop(xoff,yoff,count,spread,town,rem,spike) {

// clockwise spiral out
local trytilegrid = [((AIMap.GetTileX(AITown.GetLocation(town)))+xoff),((AIMap.GetTileY(AITown.GetLocation(town)))+yoff)]
local trytile;
local aimx; // aimtile
local aimy; // aimtile
local aimxm; // an additional aimtile, for bridge approach tests (we don't build on bridge approaches, because they send us on journeys)
local aimym; // an additional aimtile, for bridge approach tests (we don't build on bridge approaches, because they send us on journeys)
local testroad = RoadPF();
testroad.cost.no_existing_road = testroad.cost.max_cost;
local x = 0
local y = 0
local i = 0
local stat = AIStation.STATION_NEW

local statcount = 0

while ((i < spread) && (statcount < count)) {
//y--
for (;y >= 0-i;y--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
aimx  = AIMap.GetTileIndex(trytilegrid[0]+x+1,trytilegrid[1]+y);
aimy  = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y+1);
aimxm  = AIMap.GetTileIndex(trytilegrid[0]+x-1,trytilegrid[1]+y);
aimym  = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y-1);

testroad.InitializePath([trytile], [AITown.GetLocation(town)]);
local path = false;
while (path == false) {
path = testroad.FindPath(20);
AIController.Sleep(1);
}

if (rem) {
AIRoad.RemoveRoadStation(trytile) } else
if ((path != null) && (statcount < count) && (AITile.GetCargoAcceptance(trytile, 0, 1, 1, 3) > 11) && (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD))) {
	if (!AIBridge.IsBridgeTile(aimx) && !AIBridge.IsBridgeTile(aimxm) && 
	(AITile.GetSlope(aimx) == AITile.SLOPE_FLAT) &&
	(AITile.GetSlope(aimxm) == AITile.SLOPE_FLAT) &&
	AIRoad.BuildDriveThroughRoadStation(trytile,aimx,AIRoad.ROADVEHTYPE_BUS,stat)) {
	stat = AIStation.GetStationID(trytile), statcount = statcount+1
		if (spike) { 
		SpikeX(trytile,town); 
		} 
		}
	else if (!AIBridge.IsBridgeTile(aimy) && !AIBridge.IsBridgeTile(aimym) && 
	(AITile.GetSlope(aimy) == AITile.SLOPE_FLAT) &&
	(AITile.GetSlope(aimym) == AITile.SLOPE_FLAT) &&
	AIRoad.BuildDriveThroughRoadStation(trytile,aimy,AIRoad.ROADVEHTYPE_BUS,stat)) {
	stat = AIStation.GetStationID(trytile), statcount = statcount+1
		if (spike) { 
		SpikeY(trytile,town); 
		} 
		}
}
}

//x--;
for (;x >= 0-i;x--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
aimx  = AIMap.GetTileIndex(trytilegrid[0]+x+1,trytilegrid[1]+y);
aimy  = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y+1);
aimxm  = AIMap.GetTileIndex(trytilegrid[0]+x-1,trytilegrid[1]+y);
aimym  = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y-1);

testroad.InitializePath([trytile], [AITown.GetLocation(town)]);
local path = false;
while (path == false) {
path = testroad.FindPath(20);
AIController.Sleep(1);
}
if (rem) {
AIRoad.RemoveRoadStation(trytile) } else
if ((path != null) && (statcount < count) && (AITile.GetCargoAcceptance(trytile, 0, 1, 1, 3) > 11) && (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD))) {
	if (!AIBridge.IsBridgeTile(aimx) && !AIBridge.IsBridgeTile(aimxm) && 
	(AITile.GetSlope(aimx) == AITile.SLOPE_FLAT) &&
	(AITile.GetSlope(aimxm) == AITile.SLOPE_FLAT) &&
	AIRoad.BuildDriveThroughRoadStation(trytile,aimx,AIRoad.ROADVEHTYPE_BUS,stat)) {
	stat = AIStation.GetStationID(trytile), statcount = statcount+1
		if (spike) { 
		SpikeX(trytile,town); 
		} 
		}
	else if (!AIBridge.IsBridgeTile(aimy) && !AIBridge.IsBridgeTile(aimym) && 
	(AITile.GetSlope(aimy) == AITile.SLOPE_FLAT) &&
	(AITile.GetSlope(aimym) == AITile.SLOPE_FLAT) &&
	AIRoad.BuildDriveThroughRoadStation(trytile,aimy,AIRoad.ROADVEHTYPE_BUS,stat)) {
	stat = AIStation.GetStationID(trytile), statcount = statcount+1
		if (spike) { 
		SpikeY(trytile,town); 
		} 
		}
}
}

//y++;
for (;y <= i;y++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
aimx  = AIMap.GetTileIndex(trytilegrid[0]+x+1,trytilegrid[1]+y);
aimy  = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y+1);
aimxm  = AIMap.GetTileIndex(trytilegrid[0]+x-1,trytilegrid[1]+y);
aimym  = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y-1);

testroad.InitializePath([trytile], [AITown.GetLocation(town)]);
local path = false;
while (path == false) {
path = testroad.FindPath(20);
AIController.Sleep(1);
}
if (rem) {
AIRoad.RemoveRoadStation(trytile) } else
if ((path != null) && (statcount < count) && (AITile.GetCargoAcceptance(trytile, 0, 1, 1, 3) > 11) && (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD))) {
	if (!AIBridge.IsBridgeTile(aimx) && !AIBridge.IsBridgeTile(aimxm) && 
	(AITile.GetSlope(aimx) == AITile.SLOPE_FLAT) &&
	(AITile.GetSlope(aimxm) == AITile.SLOPE_FLAT) &&
	AIRoad.BuildDriveThroughRoadStation(trytile,aimx,AIRoad.ROADVEHTYPE_BUS,stat)) {
	stat = AIStation.GetStationID(trytile), statcount = statcount+1
		if (spike) { 
		SpikeX(trytile,town); 
		} 
		}
	else if (!AIBridge.IsBridgeTile(aimy) && !AIBridge.IsBridgeTile(aimym) && 
	(AITile.GetSlope(aimy) == AITile.SLOPE_FLAT) &&
	(AITile.GetSlope(aimym) == AITile.SLOPE_FLAT) &&
	AIRoad.BuildDriveThroughRoadStation(trytile,aimy,AIRoad.ROADVEHTYPE_BUS,stat)) {
	stat = AIStation.GetStationID(trytile), statcount = statcount+1
		if (spike) { 
		SpikeY(trytile,town); 
		} 
		}
}
}

//x++;
for (;x <= i+1;x++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
aimx  = AIMap.GetTileIndex(trytilegrid[0]+x+1,trytilegrid[1]+y);
aimy  = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y+1);
aimxm  = AIMap.GetTileIndex(trytilegrid[0]+x-1,trytilegrid[1]+y);
aimym  = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y-1);

testroad.InitializePath([trytile], [AITown.GetLocation(town)]);
local path = false;
while (path == false) {
path = testroad.FindPath(20);
AIController.Sleep(1);
}
if (rem) {
AIRoad.RemoveRoadStation(trytile) } else
if ((path != null) && (statcount < count) && (AITile.GetCargoAcceptance(trytile, 0, 1, 1, 3) > 11) && (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD))) {
	if (!AIBridge.IsBridgeTile(aimx) && !AIBridge.IsBridgeTile(aimxm) && 
	(AITile.GetSlope(aimx) == AITile.SLOPE_FLAT) &&
	(AITile.GetSlope(aimxm) == AITile.SLOPE_FLAT) &&
	AIRoad.BuildDriveThroughRoadStation(trytile,aimx,AIRoad.ROADVEHTYPE_BUS,stat)) {
	stat = AIStation.GetStationID(trytile), statcount = statcount+1
		if (spike) { 
		SpikeX(trytile,town); 
		} 
		}
	else if (!AIBridge.IsBridgeTile(aimy) && !AIBridge.IsBridgeTile(aimym) && 
	(AITile.GetSlope(aimy) == AITile.SLOPE_FLAT) &&
	(AITile.GetSlope(aimym) == AITile.SLOPE_FLAT) &&
	AIRoad.BuildDriveThroughRoadStation(trytile,aimy,AIRoad.ROADVEHTYPE_BUS,stat)) {
	stat = AIStation.GetStationID(trytile), statcount = statcount+1
		if (spike) { 
		SpikeY(trytile,town); 
		} 
		}
}
}
i=i+1
}
if (statcount > 0) { return stat+1 } else { return false }
}

// ====================================================== 
//                BUILD TURNAROUND SPIKES
// ====================================================== 

function CivilAI::SpikeX(tile,town) {

local x = AIMap.GetTileX(tile)
local y = AIMap.GetTileY(tile)
local townx = AIMap.GetTileX(AITown.GetLocation(town))

if (x >= townx) {
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x+1,y+1),
AIMap.GetTileIndex(x+1,y)
); 
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x+1,y-1),
AIMap.GetTileIndex(x+1,y)
);
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x+2,y),
tile
);

local lback = false
local lplus = false
local lminus = false

if (AITile.HasTransportType(AIMap.GetTileIndex(x+1,y+1),AITile.TRANSPORT_ROAD)) { lplus = true }
if (AITile.HasTransportType(AIMap.GetTileIndex(x+1,y-1),AITile.TRANSPORT_ROAD)) { lminus = true }
if (AITile.HasTransportType(AIMap.GetTileIndex(x+1,y),AITile.TRANSPORT_ROAD) && AITile.HasTransportType(AIMap.GetTileIndex(x+2,y),AITile.TRANSPORT_ROAD)) { lback = true }

if (lback && lplus 
&& (AITile.GetSlope(AIMap.GetTileIndex(x+2,y+1)) == AITile.SLOPE_FLAT)) {

// attempt to build a plus loop	 
local looptile = (AIMap.GetTileIndex(x+2,y+1)) 	
if (!(AITile.HasTransportType(looptile,AITile.TRANSPORT_ROAD))) { AITile.DemolishTile(looptile) } 
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x+2,y)
);
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x+1,y+1)
);
	 
} else if (lback && lminus 
&& (AITile.GetSlope(AIMap.GetTileIndex(x+2,y-1)) == AITile.SLOPE_FLAT)) {

// attempt to build a minus loop	
local looptile = (AIMap.GetTileIndex(x+2,y-1)) 	  
if (!(AITile.HasTransportType(looptile,AITile.TRANSPORT_ROAD))) { AITile.DemolishTile(looptile) } 
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x+2,y)
);
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x+1,y-1)
);	 
}

}
if (x <= townx) {
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x-1,y+1),
AIMap.GetTileIndex(x-1,y)
); 
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x-1,y-1),
AIMap.GetTileIndex(x-1,y)
);
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x-2,y),
tile
);

local lback = false
local lplus = false
local lminus = false

if (AITile.HasTransportType(AIMap.GetTileIndex(x-1,y+1),AITile.TRANSPORT_ROAD)) { lplus = true }
if (AITile.HasTransportType(AIMap.GetTileIndex(x-1,y-1),AITile.TRANSPORT_ROAD)) { lminus = true }
if (AITile.HasTransportType(AIMap.GetTileIndex(x-1,y),AITile.TRANSPORT_ROAD) && AITile.HasTransportType(AIMap.GetTileIndex(x-2,y),AITile.TRANSPORT_ROAD)) { lback = true }

if (lback && lplus 
&& (AITile.GetSlope(AIMap.GetTileIndex(x-2,y+1)) == AITile.SLOPE_FLAT)) {

// attempt to build a plus loop	
local looptile = (AIMap.GetTileIndex(x-2,y+1)) 
if (!(AITile.HasTransportType(looptile,AITile.TRANSPORT_ROAD))) { AITile.DemolishTile(looptile) } 

AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x-2,y)
);
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x-1,y+1)
);
	 
} else if (lback && lminus 
&& (AITile.GetSlope(AIMap.GetTileIndex(x-2,y-1)) == AITile.SLOPE_FLAT)) {

// attempt to build a minus loop
local looptile = (AIMap.GetTileIndex(x-2,y-1)) 	 
if (!(AITile.HasTransportType(looptile,AITile.TRANSPORT_ROAD))) { AITile.DemolishTile(looptile) } 
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x-2,y)
);
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x-1,y-1)
);	 
}

}
return
}

function CivilAI::SpikeY(tile,town) {

local x = AIMap.GetTileX(tile)
local y = AIMap.GetTileY(tile)
local towny = AIMap.GetTileY(AITown.GetLocation(town))

if (y >= towny) {
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x+1,y+1),
AIMap.GetTileIndex(x,y+1)
);
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x-1,y+1),
AIMap.GetTileIndex(x,y+1)
);
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x,y+2),
tile
);

local lback = false
local lplus = false
local lminus = false

if (AITile.HasTransportType(AIMap.GetTileIndex(x+1,y+1),AITile.TRANSPORT_ROAD)) { lplus = true }
if (AITile.HasTransportType(AIMap.GetTileIndex(x-1,y+1),AITile.TRANSPORT_ROAD)) { lminus = true }
if (AITile.HasTransportType(AIMap.GetTileIndex(x,y+1),AITile.TRANSPORT_ROAD) && AITile.HasTransportType(AIMap.GetTileIndex(x,y+2),AITile.TRANSPORT_ROAD)) { lback = true }

if (lback && lplus 
&& (AITile.GetSlope(AIMap.GetTileIndex(x+1,y+2)) == AITile.SLOPE_FLAT)) {

// attempt to build a plus loop	 
local looptile = (AIMap.GetTileIndex(x+1,y+2)) 	 
if (!(AITile.HasTransportType(looptile,AITile.TRANSPORT_ROAD))) { AITile.DemolishTile(looptile) } 
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x,y+2)
);
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x+1,y+1)
);
	 
} else if (lback && lminus 
&& (AITile.GetSlope(AIMap.GetTileIndex(x-1,y+2)) == AITile.SLOPE_FLAT)) {

// attempt to build a minus loop	
local looptile = (AIMap.GetTileIndex(x-1,y+2)) 	 
if (!(AITile.HasTransportType(looptile,AITile.TRANSPORT_ROAD))) { AITile.DemolishTile(looptile) } 
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x,y+2)
);
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x-1,y+1)
); 
}

}
if (y <= towny) {
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x+1,y-1),
AIMap.GetTileIndex(x,y-1)
);
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x-1,y-1),
AIMap.GetTileIndex(x,y-1)
);
AIRoad.BuildRoadFull(
AIMap.GetTileIndex(x,y-2),
tile
);

local lback = false
local lplus = false
local lminus = false

if (AITile.HasTransportType(AIMap.GetTileIndex(x+1,y-1),AITile.TRANSPORT_ROAD)) { lplus = true }
if (AITile.HasTransportType(AIMap.GetTileIndex(x-1,y-1),AITile.TRANSPORT_ROAD)) { lminus = true }
if (AITile.HasTransportType(AIMap.GetTileIndex(x,y-1),AITile.TRANSPORT_ROAD) && AITile.HasTransportType(AIMap.GetTileIndex(x,y-2),AITile.TRANSPORT_ROAD)) { lback = true }

if (lback && lplus 
&& (AITile.GetSlope(AIMap.GetTileIndex(x+1,y-2)) == AITile.SLOPE_FLAT)) {

// attempt to build a plus loop	 
local looptile = (AIMap.GetTileIndex(x+1,y-2)) 	 
if (!(AITile.HasTransportType(looptile,AITile.TRANSPORT_ROAD))) { AITile.DemolishTile(looptile) } 
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x,y-2)
);
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x+1,y-1)
);
	 
} else if (lback && lminus 
&& (AITile.GetSlope(AIMap.GetTileIndex(x-1,y-2)) == AITile.SLOPE_FLAT)) {

// attempt to build a minus loop	
local looptile = (AIMap.GetTileIndex(x-1,y-2)) 	 
if (!(AITile.HasTransportType(looptile,AITile.TRANSPORT_ROAD))) { AITile.DemolishTile(looptile) } 
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x,y-2)
);
AIRoad.BuildRoad(
looptile,
AIMap.GetTileIndex(x-1,y-1)
); 
}

}
return
}



// ====================================================== 
//                    FIND BUSES TO BUY
// ======================================================  


function CivilAI::IdentifyBus(silent) {
local busid= 0;
local vlist= 0;
local blist= 0;
local bcap = 0;
local bdate= 0;
local z = 0;

vlist = AIEngineList(AIVehicle.VT_ROAD); 	// list of all road vehicles

foreach (rv,z in vlist) {

//AILog.Info("Assessing " + AIEngine.GetName(rv));

if ((AIEngine.IsBuildable(rv)) 
&& (AIEngine.CanRefitCargo(rv, 0))					// again with the assumption that pax = 0
&& (AIEngine.GetCapacity(rv) > 9)	
&& (AIEngine.GetRoadType(rv) == AIRoad.ROADTYPE_ROAD)) {

if (AIEngine.GetCapacity(rv) > bcap) {				    // highest capacity.
// AILog.Info("!");
 busid = rv+1	
 bcap = AIEngine.GetCapacity(rv)
 bdate =  AIEngine.GetDesignDate(rv)
  } else if ((AIEngine.GetCapacity(rv) == bcap) &&  
		   (AIEngine.GetDesignDate(rv) > bdate))	{	// If a tie, we want the newest.
 busid = rv+1	
 bcap = AIEngine.GetCapacity(rv)
 bdate =  AIEngine.GetDesignDate(rv)
  }
  }
  }
  
if (busid > 0) {
if (!silent) AILog.Info("I've selected " + AIEngine.GetName(busid-1)  + " for local buses.")
return (busid);
} else {
if (!silent) AILog.Info("I can't find any buses available to buy...")
return false;
}
}

// ====================================================== 
//                    FIND COACHES TO BUY
// ====================================================== 

function CivilAI::IdentifyCoach(silent) {
local busid= 0;
local vlist= 0;
local blist= 0;
local bcap = 0;
local bdate= 0;
local z = 0;

vlist = AIEngineList(AIVehicle.VT_ROAD); 	// list of all road vehicles

foreach (rv,z in vlist) {

//AILog.Info("Assessing " + AIEngine.GetName(rv));

if ((AIEngine.IsBuildable(rv)) 
&& (AIEngine.CanRefitCargo(rv, 0))					// again with the assumption that pax = 0
&& (AIEngine.GetCapacity(rv) > 9)	
&& (AIEngine.GetRoadType(rv) == AIRoad.ROADTYPE_ROAD)) {

if (AIEngine.GetMaxSpeed(rv) > bcap) {				    // highest speed.
// AILog.Info("!");
 busid = rv+1	
 bcap = AIEngine.GetMaxSpeed(rv)
 bdate =  AIEngine.GetDesignDate(rv)
  } else if ((AIEngine.GetCapacity(rv) == bcap) &&  
		   (AIEngine.GetDesignDate(rv) > bdate))	{	// If a tie, we want the newest.
 busid = rv+1	
 bcap = AIEngine.GetMaxSpeed(rv)
 bdate =  AIEngine.GetDesignDate(rv)
  }
  }
  }
if (busid > 0) {
if (!silent) AILog.Info("I've selected " + AIEngine.GetName(busid-1)  + " for intercity buses.")
return (busid);
} else {
if (!silent) AILog.Info("I can't find any buses available to buy...")
return false;
}
}  

// ====================================================== 
//                  BUY BUSES FOR ROUTE
// ====================================================== 

function CivilAI::CreateRoute(vehicle,count,stops,depot,routename,fullload) {

local obus
local clonebus
local stop
local nx
local name
local changename = false


obus = (AIVehicle.BuildVehicle(depot,vehicle-1)); 
if (AIVehicle.IsValidVehicle(obus)) {
foreach (stop in stops) {
if (fullload) {
AIOrder.AppendOrder(obus, AIBaseStation.GetLocation(stop-1),(AIOrder.OF_NON_STOP_INTERMEDIATE + AIOrder.OF_FULL_LOAD_ANY))
} else {
AIOrder.AppendOrder(obus, AIBaseStation.GetLocation(stop-1),(AIOrder.OF_NON_STOP_INTERMEDIATE))
}
}
nx = 0
name = null
changename = false
while (!changename && (nx < 1000)) {
nx++ 
name = (routename + " " + nx)
changename = AIVehicle.SetName(obus,name)
}
AILog.Info("I've bought a bus for " + routename + ".")
AIGroup.MoveVehicle(Groups[0], obus); // add to appropriate group
AIVehicle.StartStopVehicle(obus);

} else {
AILog.Info("For some reason (probably not enough money), I couldn't buy a bus for " + routename + ".")
}

for (local c = 1; c < count; c++) {

clonebus = AIVehicle.BuildVehicle(depot,vehicle-1)
if (AIVehicle.IsValidVehicle(clonebus)) {
AIOrder.ShareOrders(clonebus,obus);

nx = 0
name = null
changename = false
while (!changename && (nx < 1000)) {
nx++ 
name = (routename + " " + nx)
changename = AIVehicle.SetName(clonebus,name)
}
AIOrder.SkipToOrder(clonebus,AIBase.RandRange(AIOrder.GetOrderCount(clonebus)));
AILog.Info("I've bought another bus for " + routename + ".")
AIGroup.MoveVehicle(Groups[0], clonebus); // add to appropriate group
AIVehicle.StartStopVehicle(clonebus);
} else {
AILog.Info("For some reason (probably not enough money), I couldn't buy a bus for " + routename + ".")

}
}

return
}

// ====================================================== 
//                 REVIEW BUS SERVICES
// ====================================================== 

function CivilAI::BusReview() {

AILog.Info("I'm reviewing my bus services.");	
CashUp();

// remove unused stops
local bslist = AIStationList(AIStation.STATION_BUS_STOP); 
local vlist
foreach (stop,z in bslist) {
vlist = AIVehicleList_Station(stop)
foreach (veh,z in vlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_ROAD) {
vlist.RemoveItem(veh);
}
} 
if (vlist.Count() == 0) {	
AILog.Info((AIBaseStation.GetName(stop)) + " has no service. I'll remove the stop.")
if (!AIRoad.RemoveRoadStation(AIBaseStation.GetLocation(stop))) {
BuildBusStop (0,0,4,3,(AIStation.GetNearestTown(stop)),true,false); // remove central stops.
}
}
}

local dosh = ((AICompany.GetMaxLoanAmount() - AICompany.GetLoanAmount()) + AICompany.GetBankBalance(Me));
local nbus = IdentifyBus(true);

if (nbus == false) {
CashDown();
return;
}
else if (dosh > (AIEngine.GetPrice(nbus-1) * 5)) {


// replacing old buses?
local rvlist
rvlist = AIVehicleList();

for (local v = rvlist.Begin(); !(rvlist.IsEnd()); v = rvlist.Next()) {
if  ((AIVehicle.GetCapacity(v,0) > 9) &&
	((AIVehicle.GetAgeLeft(v)) < (365 * 1))) {

// clone the old bus

local obus = v;
local upbus

// compare orders; if first two orders are in different towns, build a coach instead of a bus
local order1 = AIOrder.GetOrderDestination(obus, 0)
local order2 = AIOrder.GetOrderDestination(obus, 1)
if (AITile.GetClosestTown(order1) == AITile.GetClosestTown(order2)) {
upbus = IdentifyBus(true);
} else {
upbus = IdentifyCoach(true);
}

local clonebus = AIVehicle.BuildVehicle(HomeDepot,upbus-1)
if (AIVehicle.IsValidVehicle(clonebus)) {
//AILog.Info("I've bought a replacement for " + (AIVehicle.GetName(v)) + ".")
AIOrder.ShareOrders(clonebus,obus);
local nx = 0
local name = null
local changename = false

local stopp = (AIStation.GetStationID(AIOrder.GetOrderDestination(obus,0)));

while (!changename && (nx < 1000)) {
nx++ 
name = ((AITown.GetName(AIStation.GetNearestTown(stopp))) + " " + nx)
changename = AIVehicle.SetName(clonebus,name)
}
AIOrder.SkipToOrder(clonebus,AIBase.RandRange(6));
AIGroup.MoveVehicle(Groups[0], clonebus); // add to appropriate group
AIVehicle.StartStopVehicle(clonebus);

AIVehicle.SendVehicleToDepot(obus);
AILog.Info(AIVehicle.GetName(obus) + " is getting old, so I'm replacing it.")

} else {
AILog.Info("For some reason (probably not enough money), I couldn't buy a replacement for " + (AIVehicle.GetName(obus)) + ".")
}
}
}

// do we want to add more buses?

// check we don't have MaxBus
local rvlist = AIVehicleList();
foreach (veh,z in rvlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_ROAD) {
rvlist.RemoveItem(veh);
}
}
rvlist.Valuate(AIVehicle.GetCapacity, 0);
rvlist.KeepAboveValue(9);
local buscount = rvlist.Count();
if (buscount < MaxBus) {

local bslist = AIStationList(AIStation.STATION_BUS_STOP); 
local vlist
local clonebus
local obus
local upbus

foreach (stop,z in bslist) {
if (((AIStation.GetCargoWaiting(stop,0) > 500) && 
    (AIStation.GetCargoRating(stop,0) < 60)) ||
	(AIStation.GetCargoRating(stop,0) < 40)  ||
	!(AIStation.HasCargoRating(stop,0))) // grabs stops which have never been serviced
	{	
// find a bus that uses this stop and copy it in the home depot	
vlist = AIVehicleList_Station(stop)
foreach (veh,z in vlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_ROAD) {
vlist.RemoveItem(veh);
}
} 
if (vlist.Count() == 0) {	
AILog.Info((AIBaseStation.GetName(stop)) + " has no service, so I can't clone the route. I'll remove the stop instead.")
if (!AIRoad.RemoveRoadStation(AIBaseStation.GetLocation(stop))) {
BuildBusStop (0,0,4,3,(AIStation.GetNearestTown(stop)),true,false); // remove central stops.
}	
} else if (vlist.Count() < 8) {		
obus = vlist.Begin();		

// compare orders; if first two orders are in different towns, build a coach instead of a bus
local order1 = AIOrder.GetOrderDestination(obus, 0)
local order2 = AIOrder.GetOrderDestination(obus, 1)
if (AITile.GetClosestTown(order1) == AITile.GetClosestTown(order2)) {
upbus = IdentifyBus(true);
} else {
upbus = IdentifyCoach(true);
}

clonebus = AIVehicle.BuildVehicle(HomeDepot,upbus-1)
if (AIVehicle.IsValidVehicle(clonebus)) {
AILog.Info("I've bought another bus for " + AITown.GetName(AIStation.GetNearestTown(stop)) + ".")
AIOrder.ShareOrders(clonebus,obus);
local nx = 0
local name = null
local changename = false

while (!changename && (nx < 1000)) {
nx++ 
name = ((AITown.GetName(AIStation.GetNearestTown(stop))) + " " + nx)
changename = AIVehicle.SetName(clonebus,name)
}
AIOrder.SkipToOrder(clonebus,AIBase.RandRange(6));
AIGroup.MoveVehicle(Groups[0], clonebus); // add to appropriate group
AIVehicle.StartStopVehicle(clonebus);
} else {
AILog.Info("For some reason (probably not enough money), I couldn't buy a bus for " + AITown.GetName(AIStation.GetNearestTown(stop)) + ".")
}	
} else {
// AILog.Info("I won't buy another bus for " + (AIBaseStation.GetName(stop)) + ", because it's already crowded.")
}
}
}
} else {
AILog.Info("I've already got my maximum number of buses, so I won't build more.")
}
} else {
AILog.Info("I don't have the money for new buses at the moment.")
}


// do we want to remove unprofitable buses?

local rvlist = AIVehicleList();
foreach (veh,z in rvlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_ROAD) {
rvlist.RemoveItem(veh);
}
}

for (local v = rvlist.Begin(); !(rvlist.IsEnd()); v = rvlist.Next()) {
if  ((AIVehicle.GetProfitLastYear(v) < 0) &&
	(AIVehicle.GetCapacity(v,0) > 9) &&
	(AIVehicle.GetAge(v) > (365*2))) {
	AIVehicle.SendVehicleToDepot(v);
	AILog.Info(AIVehicle.GetName(v) + " is losing money, so I'm sending it to the depot.")	
	}
}
CashDown();
return
}


// ====================================================== 
//               CLEAN VEHICLES FROM DEPOT
// ====================================================== 

function CivilAI::DepotClean() {

AILog.Info("I'm clearing out old vehicles from my depots.");

local rvlist = AIVehicleList();
local c = 0;

for (local v = rvlist.Begin(); !(rvlist.IsEnd()); v = rvlist.Next()) {
if  (AIVehicle.IsStoppedInDepot(v)) {
	AIVehicle.SellVehicle(v);
	c++	
	}
	}
if (c == 0) {	
AILog.Info("I found nothing to sell.")
} else if (c == 1) {	
AILog.Info("I've disposed of " + c + " vehicle.")
} else {
AILog.Info("I've disposed of " + c + " vehicles.")
}

return	
}

// ====================================================== 
//               BUILD ADDITIONAL NETWORKS
// ====================================================== 

function CivilAI::NewNetwork() {

local dosh = ((AICompany.GetMaxLoanAmount() - AICompany.GetLoanAmount()) + AICompany.GetBankBalance(Me));
local nbus = IdentifyBus(false);

if (nbus == false) {
return;
}
else if (dosh > (AIEngine.GetPrice(nbus-1) * 5)) {

// check we don't have MaxBus
local rvlist = AIVehicleList();
foreach (veh,z in rvlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_ROAD) {
rvlist.RemoveItem(veh);
}
}
rvlist.Valuate(AIVehicle.GetCapacity, 0);
rvlist.KeepAboveValue(9);
local buscount = rvlist.Count();
if (buscount < MaxBus) {

AILog.Info("I'm looking for a town to build a new bus network in.");

// find a town

local townlist = MyTownList();
townlist.Valuate(AITown.GetPopulation);
townlist.RemoveBelowValue(MinPop);

foreach (town,z in townlist) {
if ((AITown.GetLastMonthSupplied(town, 0) * 20) > AITown.GetPopulation(town)) {
townlist.RemoveItem(town);  // discard sufficiently serviced towns
//AILog.Info("Discarding " + AITown.GetName(town) + " as sufficiently serviced.");

// build a depot anyway for our towncars
local dlist = AIDepotList(AITile.TRANSPORT_ROAD); 
foreach (depot,z in dlist) {
	if (AITile.GetClosestTown(depot) != town) {
		dlist.RemoveItem(depot);	
		}
	}
if (dlist.Count() == 0) {
NewDepot(town, false);
//AILog.Info("Building a depot only (for towncars) in " + AITown.GetName(town) + ".");
}

} else {
local bslist = AIStationList(AIStation.STATION_BUS_STOP);
foreach (stat,z in bslist) {
if (AIStation.GetNearestTown(stat) == (town)) {
townlist.RemoveItem(town);  // discard self-serviced towns
//AILog.Info("Discarding " + AITown.GetName(town) + " as self-serviced.");
break;
}
}
}
}

if (townlist.Count() > 0) {
townlist.Valuate(AIBase.RandItem); // shuffle the town list
local newtown = townlist.Begin();

// build a new network. First, check for an existing depot
CashUp();

local dlist = AIDepotList(AITile.TRANSPORT_ROAD); 
foreach (depot,z in dlist) {
	if (AITile.GetClosestTown(depot) != newtown) {
		dlist.RemoveItem(depot);	
		}
	}
if (dlist.Count() == 0) {
NewDepot(newtown, true);
} else {
BuildBuses(newtown,dlist.Begin());
}
CashDown();
} else {
AILog.Info("I couldn't find one.");
}
} else {
AILog.Info("I've already got my maximum number of buses, so I won't build a new network.")
}
} else {
AILog.Info("I don't have the money for a new network at the moment.")
}
return
}

// ====================================================== 
//          BUILD ADDITIONAL DEPOT FOR NETWORK
// ====================================================== 

function CivilAI::NewDepot(town, buildbuses) {

// clockwise spiral out
local trytilegrid = [AIMap.GetTileX(AITown.GetLocation(town)),AIMap.GetTileY(AITown.GetLocation(town))]
local trytile;
local x = 1
local y = 1
local i = 5
local depot = 0
while ((depot == 0) && (i < 20)) {
//y--
for (;y >= 0-i;y--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, "?");
//AILog.Info("testing tile at " + x + "," + y);
if (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD) 
&& !AIRoad.IsRoadDepotTile(trytile)
&& !AIRoad.IsRoadStationTile(trytile)
&& !AIRoad.IsDriveThroughRoadStationTile(trytile)
&& !AIBridge.IsBridgeTile(trytile)
&& !depot)
depot = BuildDepot(trytile,town);
}
//x--;
for (;x >= 0-i;x--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, "?");
//AILog.Info("testing tile at " + x + "," + y);
if (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD) 
&& !AIRoad.IsRoadDepotTile(trytile)
&& !AIRoad.IsRoadStationTile(trytile)
&& !AIRoad.IsDriveThroughRoadStationTile(trytile)
&& !AIBridge.IsBridgeTile(trytile)
&& !depot)
depot = BuildDepot(trytile,town);
}
//y++;
for (;y <= i;y++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, "?");
//AILog.Info("testing tile at " + x + "," + y);
if (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD)
&& !AIRoad.IsRoadDepotTile(trytile)
&& !AIRoad.IsRoadStationTile(trytile)
&& !AIRoad.IsDriveThroughRoadStationTile(trytile)
&& !AIBridge.IsBridgeTile(trytile)
&& !depot)
depot = BuildDepot(trytile,town);
}
//x++;
for (;x <= i;x++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, "?");
//AILog.Info("testing tile at " + x + "," + y);
if (AIRoad.HasRoadType(trytile,AIRoad.ROADTYPE_ROAD)
&& !AIRoad.IsRoadDepotTile(trytile)
&& !AIRoad.IsRoadStationTile(trytile)
&& !AIRoad.IsDriveThroughRoadStationTile(trytile)
&& !AIBridge.IsBridgeTile(trytile)
&& !depot)
depot = BuildDepot(trytile,town);
}
i=i+1
}

if (depot) {
AILog.Info("I've built a new depot at " + AIMap.GetTileX(depot) + "," + AIMap.GetTileY(depot) + "."); 
if (buildbuses) {
BuildBuses(town,depot);
}
} else {
AILog.Info("I couldn't find a suitable location for a depot in " + AITown.GetName(town) + ".");
return
}
}

//<
// ====================================================== 
// ====================================================== 
//         RRRRR     OOOO      AAAA     DDDD
//         R   RR   O    O    A    A    D  DD
//         RRRRR   OO    OO   AAAAAA    D   DD
//         R   R    O    O    A    A    D  DD
//         R    R    OOOO     A    A    DDDD
// ====================================================== 
// ====================================================== 
//>
// ====================================================== 
//                  CHOOSE ROAD CONNECTION
// ====================================================== 

function CivilAI::MappaMundi() {

//AILog.Info("I'm connecting towns with road.");

local hq = AICompany.GetCompanyHQ(Me);
local townlist = AITownList();

 // sort by distance from the hq
townlist.Valuate(AITown.GetDistanceManhattanToTile, hq);
townlist.KeepBelowValue(NetworkRadius); // remove towns which are too far away
townlist.RemoveList(Dudtowns); // remove known unconnectables

townlist.Sort(AIList.SORT_BY_VALUE,true);

// add the home town's home tile to the target list
local hometown = townlist.Begin();
local mapnodes = [AITown.GetLocation(hometown)] 
local nodecount = 1
local target = -1

foreach (town,z in townlist) {

local testroad = RoadPF();
local towntile = AITown.GetLocation(town);
if (!AITile.HasTransportType(towntile,AITile.TRANSPORT_ROAD) && (AITown.GetRoadReworkDuration(town) == 0)) {
Dudtowns.AddItem(town,0) // add this town to a list of unreachables
AILog.Info(AITown.GetName(town) + " has no central road tile.")
} else {
testroad.cost.no_existing_road = testroad.cost.max_cost; // only check existing roads
testroad.InitializePath([towntile], mapnodes);

local path = false;
while (path == false) {
path = testroad.FindPath(50);
AIController.Sleep(3);
}

if (path != null) { 			// we are connected already
mapnodes.append(towntile); // add this town to the nodes we can connect to
nodecount ++
// AILog.Info(AITown.GetName(town) + " is connected.")
} else {
target = town;
break;
}
}
}

local a
local b

if (target != -1) {
a = [AITown.GetLocation(target)]
b = mapnodes

BuildARoad(a,b,target)
} else {
AILog.Info("I have connected all available towns to the road network.")
}

// load the list of known connected towns for the review
local townlist = MyTownList();

local rc = 0;
local ThisMonth = AIDate.GetMonth(AIDate.GetCurrentDate());
local ReviewMonth = AIDate.GetMonth(AIDate.GetCurrentDate());

while ((rc < ((townlist.Count() / 4) + 1)) && (ThisMonth == ReviewMonth)) { 
local revdist = 1000000;
local x = 0
local sstowna
local sstownb

while ((revdist > ((NetworkRadius / 2) + 64)) && (x < 100)) {
townlist.Valuate(AIBase.RandItem); // shuffle the town list
sstowna = townlist.Begin();
sstownb = townlist.Next();
a = [AITown.GetLocation(sstowna)]
b = [AITown.GetLocation(sstownb)]
revdist = AITile.GetDistanceManhattanToTile(a[0],b[0])
x++
}
BuildARoad(a,b,-1)
rc++
ThisMonth = AIDate.GetMonth(AIDate.GetCurrentDate());
}
return;
}

// ====================================================== 
//                  BUILD ROAD CONNECTION
// ====================================================== 

function CivilAI::BuildARoad(a,b,target) {
CashUp();
if (target != -1) {
// check funds allow for the connection, and a bit left over to maintain the network
// as of 1.6 we only do this check for building new links, because we want to always check eg after building bridges
local condist = NetworkRadius
local nodedist
foreach (node, loc in b) {
nodedist = AITile.GetDistanceManhattanToTile(a[0],loc)
if (nodedist < condist) condist = nodedist
}

local dosh = ((AICompany.GetMaxLoanAmount() - AICompany.GetLoanAmount()) + AICompany.GetBankBalance(Me));
if ((dosh) < (AIRoad.GetBuildCost(AIRoad.ROADTYPE_ROAD, AIRoad.BT_ROAD) * 20 * condist)) {
if (target != -1) {
AILog.Info("I can't afford to build a road to " + AITown.GetName(target)  + " right now. Perhaps later.")
}
CashDown();
return;
}	
AILog.Info("I'm connecting " + AITown.GetName(target) + " to the road network.")
} else {
AILog.Info("I'm reviewing the roads between " + AITown.GetName(AITile.GetClosestTown(a[0])) + " and " + AITown.GetName(AITile.GetClosestTown(b[0])) + ".")
}

local buildroad = RoadPF();
buildroad.cost.max_cost 			= 10000000;   //10000000;
buildroad.cost.tile     			= 100;        // 100;
buildroad.cost.no_existing_road		= 75;        //40;
buildroad.cost.turn           		= 100;        //100;
buildroad.cost.slope          		= 400;        //200;
buildroad.cost.bridge_per_tile		= 250;        //150;
buildroad.cost.tunnel_per_tile		= 500;        //120;
buildroad.cost.coast       			= 100;        //20;
buildroad.cost.max_bridge_length	= 10;          //10;
buildroad.cost.max_tunnel_length	= 20;          //20;

buildroad.InitializePath(a, b);

local path = false;
while (path == false) {
  path = buildroad.FindPath(50);
  AIController.Sleep(3);
}


if (path == null) {

Dudtowns.AddItem(target,0) // add this town to a list of unreachables
AILog.Info(AITown.GetName(target) + " seems to be unreachable.")

CashDown();
return
}

local c = 0


while (path != null) {
  local par = path.GetParent();
  if (par != null) {
    local last_node = path.GetTile();
    if (AIMap.DistanceManhattan(path.GetTile(), par.GetTile()) == 1 ) {
      if ((!AIRoad.BuildRoad(path.GetTile(), par.GetTile())) && c < 10) {
			/* An error occured while building a road. TODO: handle it. */
      }
    } else {
      /* Build a bridge or tunnel. */
      if (!AIBridge.IsBridgeTile(path.GetTile()) && !AITunnel.IsTunnelTile(path.GetTile())) {
        /* If it was a road tile, demolish it first. Do this to work around expended roadbits. */
        if (AIRoad.IsRoadTile(path.GetTile())) AITile.DemolishTile(path.GetTile());
        if (AITunnel.GetOtherTunnelEnd(path.GetTile()) == par.GetTile()) {
          if (!AITunnel.BuildTunnel(AIVehicle.VT_ROAD, path.GetTile())) {
            /* An error occured while building a tunnel. TODO: handle it. */
          }
        } else {
          local bridge_list = AIBridgeList_Length(AIMap.DistanceManhattan(path.GetTile(), par.GetTile()) + 1);
          bridge_list.Valuate(AIBridge.GetMaxSpeed);
          bridge_list.Sort(AIList.SORT_BY_VALUE, false);
          if (!AIBridge.BuildBridge(AIVehicle.VT_ROAD, bridge_list.Begin(), path.GetTile(), par.GetTile())) {
            /* An error occured while building a bridge. TODO: handle it. */
          }
        }
      }
    }
  }
  path = par;
}
//AILog.Info("I've finished road building for now.")
CashDown();
return
}

// ====================================================== 
//             FIND LEVEL XINGS TO REPLACE
// ====================================================== 

function CivilAI::XingReplace() {
while (AIEventController.IsEventWaiting()) {
local event = AIEventController.GetNextEvent();

if (event.GetEventType() == AIEvent.ET_VEHICLE_CRASHED) {
	local crash = AIEventVehicleCrashed.Convert(event);
		if (crash.GetCrashReason() == AIEventVehicleCrashed.CRASH_RV_LEVEL_CROSSING) {
			local xing = crash.GetCrashSite();
			AILog.Info("One of our vehicles got squished at " + AIMap.GetTileX(xing) + "," + AIMap.GetTileY(xing) + "."); 
			local xinggrid = [AIMap.GetTileX(xing),AIMap.GetTileY(xing)]
			// figure out crossing orientation
			
			
			if (AIRoad.AreRoadTilesConnected(AIMap.GetTileIndex(xinggrid[0],xinggrid[1]),AIMap.GetTileIndex(xinggrid[0],xinggrid[1]+1))) {
			AILog.Info("Crossing is Y-oriented."); 
			
			if (!(XinglistY.HasItem(xing))) {
				XinglistY.AddItem(xing,0); 
				AILog.Info("Added to list of crossings to remove.");
				} else {
				AILog.Info("I already know about this crossing.");
				}
				
			} else if (AIRoad.AreRoadTilesConnected(AIMap.GetTileIndex(xinggrid[0],xinggrid[1]),AIMap.GetTileIndex(xinggrid[0]+1,xinggrid[1]))) {
			//AILog.Info("Crossing is X-oriented."); 

			if (!(XinglistX.HasItem(xing))) {
				XinglistX.AddItem(xing,0); 
				AILog.Info("Added to list of crossings to remove.");
				} else {
				AILog.Info("I already know about this crossing.");
				}			
			} else {
			//AILog.Info("The crossing appears to be on a dead-end so I won't worry about it."); 			
			}
		}
	}
}
}
// ====================================================== 
//                   REPLACE LEVEL XINGS
// ====================================================== 
function CivilAI::XingReplace2() {

// pick a random crossing to replace

local xing;
local Comblist = AIList();
Comblist.AddList(XinglistX);
Comblist.AddList(XinglistY);
Comblist.Valuate(AIBase.RandItem); // shuffle the list
if (Comblist.Count() > 0) { 
xing = Comblist.Begin(); 
} else { 
	AILog.Info("No level crossings to replace at this time."); 	
	return; 
	}
			AILog.Info("Attempting to replace level crossing at " + AIMap.GetTileX(xing) + "," + AIMap.GetTileY(xing) + " with a bridge."); 	
local xinggrid = [AIMap.GetTileX(xing),AIMap.GetTileY(xing)]	
if (XinglistX.HasItem(xing)) {

	local done1 = false;
	local done2 = false;
	local xang1 = xing;
	local xang2 = xing;
	local offs = 1;
	
	// identify one end of bridge
		offs = 1;
		while (!done1) {
		 xang1 = AIMap.GetTileIndex(xinggrid[0]+offs,xinggrid[1]);
		 if (!(AIRoad.RemoveRoadFull(xing,xang1))) {
			//AILog.Info(AIError.GetLastErrorString());
				if (AIError.GetLastError() == AIError.ERR_VEHICLE_IN_THE_WAY) { break;}
		   else if (AIError.GetLastError() == AIError.ERR_OWNED_BY_ANOTHER_COMPANY) { 
							AILog.Info("Road is owned by another company. I'm abandoning replacing this crossing.");
							XinglistX.RemoveItem(xing);
							return;
					}		
		 } else {
		 //AILog.Info("Road Removed.");
		 }
		 
	if (!(AITile.HasTransportType(xang1,AITile.TRANSPORT_RAIL))) {
				if (!(AITile.DemolishTile(xang1))) {
					if (AIError.GetLastError() == AIError.ERR_VEHICLE_IN_THE_WAY) { break;
					} else {
							AILog.Info("I can't clear the bridgehead tile for some reason. I'm abandoning replacing this crossing.");
							XinglistX.RemoveItem(xing);
							return;
					}
				} else {
		//AILog.Info("Bridge end point located.");
		done1 = true;
		break;
						}		
				}
			offs ++;
		}		
		
	
	// identify other end of bridge
		offs = 1;
		while (!done2) {
		 xang2 = AIMap.GetTileIndex(xinggrid[0]-offs,xinggrid[1]);
		 if (!(AIRoad.RemoveRoadFull(xing,xang2))) {
			//AILog.Info(AIError.GetLastErrorString());
				if (AIError.GetLastError() == AIError.ERR_VEHICLE_IN_THE_WAY) { break;}
		   else if (AIError.GetLastError() == AIError.ERR_OWNED_BY_ANOTHER_COMPANY) { 
							AILog.Info("Road is owned by another company. I'm abandoning replacing this crossing.");
							XinglistX.RemoveItem(xing);
							return;
					}		
		 } else {
		 //AILog.Info("Road Removed.");
		 }
		 
	if (!(AITile.HasTransportType(xang2,AITile.TRANSPORT_RAIL))) {
				if (!(AITile.DemolishTile(xang2))) {
					if (AIError.GetLastError() == AIError.ERR_VEHICLE_IN_THE_WAY) { break;
					} else {
							AILog.Info("I can't clear the bridgehead tile for some reason. I'm abandoning replacing this crossing.");
							XinglistX.RemoveItem(xing);
							return;
					}
				} else {
		//AILog.Info("Bridge end point located.");
		done2 = true;
		break;
						}		
				}
			offs ++;
		}		

if (done1 && done2) {
		  CashUp();
          local bridge_list = AIBridgeList_Length(AIMap.DistanceManhattan(xang1, xang2));
          bridge_list.Valuate(AIBridge.GetMaxSpeed);
          bridge_list.Sort(AIList.SORT_BY_VALUE, false);
          AIBridge.BuildBridge(AIVehicle.VT_ROAD, bridge_list.Begin(), xang1, xang2); 
		  CashDown();
		  AILog.Info("Building a bridge and getting over it.");
		  XinglistX.RemoveItem(xing);

		// double-check the road connections
			// X oriented town search
			local townlist;
			local town1;
			local town2;
				
			//find nearest town to the negative	
			
			townlist = AITownList();
			foreach (town,z in townlist) {
			if (AIMap.GetTileX(AITown.GetLocation(town)) < xinggrid[0]) { townlist.RemoveItem(town); } // remove offside.
			}
			townlist.Valuate(AITown.GetDistanceManhattanToTile, xing);
			townlist.Sort(AIList.SORT_BY_VALUE,true);
			if (townlist.Count() > 0) { town1 = townlist.Begin(); } else { AILog.Info("Oops"); return; } 
			
			//find nearest town to the positive
			townlist = AITownList();
			foreach (town,z in townlist) {
			if (AIMap.GetTileX(AITown.GetLocation(town)) >= xinggrid[0]) { townlist.RemoveItem(town); } // remove offside.
			}
			townlist.Valuate(AITown.GetDistanceManhattanToTile, xing);
			townlist.Sort(AIList.SORT_BY_VALUE,true);
			if (townlist.Count() > 0) { town2 = townlist.Begin(); } else { AILog.Info("Oops"); return; } 
			
			AILog.Info("Checking road connection..."); 
			local a
			local b					
			a = [AITown.GetLocation(town1)]
			b = [AITown.GetLocation(town2)]
			BuildARoad(a,b,-1)
			return;
}			

} else if  (XinglistY.HasItem(xing)) {

	local done1 = false;
	local done2 = false;
	local xang1 = xing;
	local xang2 = xing;
	local offs = 1;
	
	// identify one end of bridge
		offs = 1;
		while (!done1) {
		 xang1 = AIMap.GetTileIndex(xinggrid[0],xinggrid[1]+offs);
		 if (!(AIRoad.RemoveRoadFull(xing,xang1))) {
			AILog.Info(AIError.GetLastErrorString());
				if (AIError.GetLastError() == AIError.ERR_VEHICLE_IN_THE_WAY) { break;}
		   else if (AIError.GetLastError() == AIError.ERR_OWNED_BY_ANOTHER_COMPANY) { 
							AILog.Info("Road is owned by another company. I'm abandoning replacing this crossing.");
							XinglistX.RemoveItem(xing);
							return;
					}		
		 } else {
		 AILog.Info("Road Removed.");
		 }
		 
	if (!(AITile.HasTransportType(xang1,AITile.TRANSPORT_RAIL))) {
				if (!(AITile.DemolishTile(xang1))) {
					if (AIError.GetLastError() == AIError.ERR_VEHICLE_IN_THE_WAY) { break;
					} else {
							AILog.Info("I can't clear the bridgehead tile for some reason. I'm abandoning replacing this crossing.");
							XinglistX.RemoveItem(xing);
							return;
					}
				} else {
		AILog.Info("Bridge end point located.");
		done1 = true;
		break;
						}		
				}
			offs ++;
		}		
		
	
	// identify other end of bridge
		offs = 1;
		while (!done2) {
		 xang2 = AIMap.GetTileIndex(xinggrid[0],xinggrid[1]-offs);
		 if (!(AIRoad.RemoveRoadFull(xing,xang2))) {
			AILog.Info(AIError.GetLastErrorString());
				if (AIError.GetLastError() == AIError.ERR_VEHICLE_IN_THE_WAY) { break;}
		   else if (AIError.GetLastError() == AIError.ERR_OWNED_BY_ANOTHER_COMPANY) { 
							AILog.Info("Road is owned by another company. I'm abandoning replacing this crossing.");
							XinglistX.RemoveItem(xing);
							return;
					}		
		 } else {
		 AILog.Info("Road Removed.");
		 }
		 
	if (!(AITile.HasTransportType(xang2,AITile.TRANSPORT_RAIL))) {
				if (!(AITile.DemolishTile(xang2))) {
					if (AIError.GetLastError() == AIError.ERR_VEHICLE_IN_THE_WAY) { break;
					} else {
							AILog.Info("I can't clear the bridgehead tile for some reason. I'm abandoning replacing this crossing.");
							XinglistX.RemoveItem(xing);
							return;
					}
				} else {
		AILog.Info("Bridge end point located.");
		done2 = true;
		break;
						}		
				}
			offs ++;
		}		

if (done1 && done2) {
		  CashUp();
          local bridge_list = AIBridgeList_Length(AIMap.DistanceManhattan(xang1, xang2));
          bridge_list.Valuate(AIBridge.GetMaxSpeed);
          bridge_list.Sort(AIList.SORT_BY_VALUE, false);
          AIBridge.BuildBridge(AIVehicle.VT_ROAD, bridge_list.Begin(), xang1, xang2); 
		  CashDown();
		  AILog.Info("Building a bridge and getting over it.");
		  XinglistY.RemoveItem(xing);


		// double-check the road connections
			// Y oriented town search
			local townlist;
			local town1;
			local town2;
						
			//find nearest town to the negative	
			townlist = AITownList();
			foreach (town,z in townlist) {
			if (AIMap.GetTileY(AITown.GetLocation(town)) < xinggrid[1]) { townlist.RemoveItem(town); } // remove offside.
			}
			townlist.Valuate(AITown.GetDistanceManhattanToTile, xing);
			townlist.Sort(AIList.SORT_BY_VALUE,true);
			if (townlist.Count() > 0) { town1 = townlist.Begin(); } else { AILog.Info("Oops"); return; } 
			
			//find nearest town to the positive
			townlist = AITownList();
			foreach (town,z in townlist) {
			if (AIMap.GetTileY(AITown.GetLocation(town)) >= xinggrid[1]) { townlist.RemoveItem(town); } // remove offside.
			}
			townlist.Valuate(AITown.GetDistanceManhattanToTile, xing);
			townlist.Sort(AIList.SORT_BY_VALUE,true);
			if (townlist.Count() > 0) { town2 = townlist.Begin(); } else { AILog.Info("Oops"); return; } 
			
			AILog.Info("Checking road connection..."); 
			local a
			local b					
			a = [AITown.GetLocation(town1)]
			b = [AITown.GetLocation(town2)]
			BuildARoad(a,b,-1)
			return;
}	


} else {
	AILog.Info("Something kooky happened while trying to figure out the crossing orientation."); 			
	return;
	}
}	

//<
// ====================================================== 
// ====================================================== 
//         CCCC     AAAA    RRRRR     SSSS
//        C    C   A    A   R   RR   SS   S
//       CC        AAAAAA   RRRRR      SS
//        C    C   A    A   R   R    S   SS
//         CCCC    A    A   R    R    SSSS
// ====================================================== 
// ====================================================== 
//>
// ====================================================== 
//                 MANAGE TOWN CARS
// ====================================================== 

function CivilAI::Vroom() {

// do we have the maximum cars?

local rvlist = AIVehicleList();
foreach (veh,z in rvlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_ROAD) {
rvlist.RemoveItem(veh);
}
}
rvlist.Valuate(AIVehicle.GetCapacity, 0);
rvlist.KeepBelowValue(10);
local carcount = rvlist.Count();
if (carcount < MaxCar) {


local vlist = AIEngineList(AIVehicle.VT_ROAD); 	// list of all road vehicles

// valid town cars have no running cost and < 10 capacity.

vlist.Valuate(AIEngine.IsValidEngine);
vlist.KeepValue(1);
vlist.Valuate(AIEngine.GetRunningCost);
vlist.KeepValue(0);
vlist.Valuate(AIEngine.GetCapacity);
vlist.KeepBelowValue(10);

if (vlist.Count() == 0) {
AILog.Info("I can't find any town cars available to buy...")
CashDown();
return
} else {

local townlist = MyTownList();

// ====================================================== 
//      calculate the maximum number of cars to buy
// ====================================================== 

// the maximum number of towncars is governed by 3 factors;
// the config setting.
// the ratio of unserved passengers.
// the total population of the network.

// get total population
local population = 0.0
foreach (town,z in townlist) {
population = (population + AITown.GetPopulation(town))
}
// get passengers produced
local totpax = 1 // add 1, just in case something goes wrong and we end up dividing by 0.
foreach (town,z in townlist) {
totpax = (totpax + AITown.GetLastMonthProduction(town, 0))  // again assuming pax = cargo 0
}
// get passengers carried
local transpax = 0
foreach (town,z in townlist) {
transpax = (transpax + (AITown.GetLastMonthProduction(town, 0) * AITown.GetLastMonthTransportedPercentage(town, 0)))
}

local unservedperc = (100 - (transpax / totpax))

local mapsize = ((AIMap.GetMapSizeX() + AIMap.GetMapSizeY() ) / 2)
if (mapsize > NetworkRadius) { mapsize = NetworkRadius }
local worldsize = ((mapsize / 64) * (mapsize / 64))


local MaxToBuild = ((MaxCar * unservedperc / 100) * (population / worldsize / 16000) * 2).tointeger();
if (MaxToBuild > MaxCar) { MaxToBuild = MaxCar }

local CarsToBuild = (MaxToBuild - carcount)

if (CarsToBuild < 1) {
AILog.Info("No drivers want new cars (" + carcount + " town cars active).")
} else if (CarsToBuild == 1) {
AILog.Info(CarsToBuild + " driver wants a new car (" + carcount + " town cars active).")
} else {
AILog.Info(CarsToBuild + " drivers want new cars (" + carcount + " town cars active).")
//AILog.Info(CarsToBuild + " drivers want new cars (" + (((population / worldsize / 160).tointeger()) + 1) +  "% population density, " + (100 - unservedperc) + "% of passengers transported, " + carcount + " town cars active).")
}
// ====================================================== 
//             purchase and name town cars
// ====================================================== 

if (CarsToBuild > BuyCar) { CarsToBuild = BuyCar }
local c = 0
local newcar
CashUp();

local dlist = AIDepotList(AITile.TRANSPORT_ROAD); 	

local namefirst = ["Jim", "Bob", "Harry", "Charlie", "Eric", "Owen", "Hans", "Keith",
				   "Mike", "Albert", "Gordon", "Dave", "Clive", "Olaf", "Anthony", "Bruce",
 				   "Kelly", "Susan", "Jessie", "Jane", "Sally", "Jean", "Ruth", "Elizabeth",
				   "Mary", "Anne", "Casey", "Kate", "Ingrid", "Lucy", "Colleen", "Julia",
				   "Gwyneth", "Sam", "Margaret", "Antonia", "Gerald", "Donald", "Colin", "Dennis",
				   "Basil", "Norma", "Jeremy", "Virginia", "Emma", "Stanley", "Gladys", "Tim"]

local namelast = ["Spriggs", "Hudson", "Simpson", "McDonald", "Clarkson", "Robertson", "Jones", "Griffith",
				  "Mills", "Palmer", "Morecambe", "Rudge", "Wells", "Evans", "Dixon", "Williams",
				  "Wood", "Foster", "Jackson", "O'Malley", "Lewis", "Deakin", "Mackintosh", "Talbot",
				  "Petersen", "Churchill", "Worthington", "Steel", "Boyd", "McGrath", "Hilton", "Smith",
				  "Hughes", "Horner", "Jones", "Brown", "Dalziel", "Menzies", "Baxter", "Bond",
				  "MacArthur", "Mayne", "Armstrong", "Waterman", "Freud", "Abbott", "Cooper", "James"]
				  

while (c < CarsToBuild) {
dlist.Valuate(AIBase.RandItem); // shuffle the list
vlist.Valuate(AIBase.RandItem); // shuffle the list
newcar = (AIVehicle.BuildVehicle(dlist.Begin(),vlist.Begin())); 
if (AIVehicle.IsValidVehicle(newcar)) {
local nx = 0
local name = null
local changename = false
while (!changename && (nx < 1000)) {
nx++ 
name = (namefirst[AIBase.RandRange(48)] + " " + namelast[AIBase.RandRange(48)])
changename = AIVehicle.SetName(newcar,name)
}
AILog.Info("I've bought a car for " + AIVehicle.GetName(newcar) + ".")
AIGroup.MoveVehicle(Groups[1], newcar); // add to appropriate group
AIVehicle.StartStopVehicle(newcar);
} else {
AILog.Info("For some reason (probably not enough money), I couldn't buy a new car.")
}
c++
}
}

} else {
AILog.Info("I've already got my maximum number of town cars, so I won't build more.")
}

// ====================================================== 
//             send old cars to the depot
// ====================================================== 

for (local v = rvlist.Begin(); !(rvlist.IsEnd()); v = rvlist.Next()) {
if  ((AIVehicle.GetAgeLeft(v) < (365 * 1)) && !(AIVehicle.IsStoppedInDepot(v)) && AIVehicle.IsValidVehicle(v)) {
AIVehicle.SendVehicleToDepot(v);
AILog.Info(AIVehicle.GetName(v) + "'s car is getting old, so I'm sending it to the depot.")
}
}
CashDown();
return
}

// ====================================================== 
//            		 Group Management
// ====================================================== 

function CivilAI::MakeGroups() {

Groups[0] = AIGroup.CreateGroup(AIVehicle.VT_ROAD);
Groups[1] = AIGroup.CreateGroup(AIVehicle.VT_ROAD);

if (AIGroup.SetName(Groups[0], "Buses")) {} else { AIGroup.SetName(Groups[0], "Buses " + Me ) }
if (AIGroup.SetName(Groups[1], "Cars")) {} else { AIGroup.SetName(Groups[1], "Cars " + Me ) }
}

function CivilAI::LoadGroups() {

local glist = AIGroupList();
foreach (group,z in glist) {

	 if (AIGroup.GetName(group) == "Buses" || AIGroup.GetName(group) == "Buses " + Me) { Groups[0] = group; } 
else if (AIGroup.GetName(group) == "Cars" || AIGroup.GetName(group) == "Cars " + Me) { Groups[1] = group; } 
}
}


//<
// ====================================================== 
// ====================================================== 
//         TTTTTT    OOOO    W     W   N   N
//           TT     O    O   WW   WW   NN  N
//           TT    OO    OO   W W W    N N N
//           TT     O    O    WWWWW    N  NN
//           TT      OOOO      W W     N   N
// ====================================================== 
// ====================================================== 
//>
// ====================================================== 
//                  LIST CONNECTED TOWNS
// ====================================================== 

function CivilAI::MyTownList() {

local hq = AICompany.GetCompanyHQ(Me);
local townlist = AITownList();
// sort by distance from the hq
townlist.Valuate(AITown.GetDistanceManhattanToTile, hq);
townlist.KeepBelowValue(NetworkRadius); // remove towns which are too far away
townlist.RemoveList(Dudtowns); // remove known unconnectables

townlist.Sort(AIList.SORT_BY_VALUE,true);

// add the home town's home tile to the target list
local hometown = townlist.Begin();
local mapnodes = [AITown.GetLocation(hometown)] 
local nodecount = 1
local target = -1

foreach (town,z in townlist) {

local testroad = RoadPF();
local towntile = AITown.GetLocation(town);
testroad.cost.no_existing_road = testroad.cost.max_cost; // only check existing roads
testroad.InitializePath([towntile], mapnodes);

local path = false;
while (path == false) {
path = testroad.FindPath(50);
AIController.Sleep(3);
}

if (path != null) { 			// we are connected already
mapnodes.append(towntile); // add this town to the nodes we can connect to
nodecount ++
// AILog.Info(AITown.GetName(town) + " is connected.")
} else {
townlist.RemoveItem(town);  // discard disconnected towns
}
}

// our townlist now contains only connected towns within the network radius.

return townlist;
}



// ====================================================== 
//                   DO TOWN STUFF
// ====================================================== 


function CivilAI::RoadWork() {

CashDown; // we don't spend borrowed money on this nonsense.

local townlist = MyTownList();
townlist.Valuate(AIBase.RandItem); // shuffle the list
local town = townlist.Begin();
local roll = AIBase.RandRange(4)

// we shan't bother iterating because it really doesn't matter if we're unsuccessful.

if (roll == 1) {
if (AITown.IsActionAvailable(town, AITown.TOWN_ACTION_BUILD_STATUE) && !(AITown.HasStatue(town))) {
AITown.PerformTownAction(town,AITown.TOWN_ACTION_BUILD_STATUE);
AILog.Info("I've built a statue to myself in " + AITown.GetName(town) + ", because I have more money than I know what to do with.")
}
} else if (roll == 2) {
if (AITown.IsActionAvailable(town, AITown.TOWN_ACTION_FUND_BUILDINGS)) {
AITown.PerformTownAction(town,AITown.TOWN_ACTION_FUND_BUILDINGS);
AILog.Info("I've funded new buildings in " + AITown.GetName(town) + ", because I have more money than I know what to do with.")
}
} else {
if (AITown.IsActionAvailable(town, AITown.TOWN_ACTION_ROAD_REBUILD)) {
AITown.PerformTownAction(town,AITown.TOWN_ACTION_ROAD_REBUILD);
AILog.Info("I've funded road rebuilding in " + AITown.GetName(town) + ", because I have more money than I know what to do with.")
}
}
CashDown;
return
}
//<
// ====================================================== 
// ====================================================== 
// 			   AAAA  	  II	  RRRRR  
// 			  A    A 	  II	  R   RR 
// 			  AAAAAA 	  II	  RRRRR  
//  		  A    A 	  II	  R   R  
//  		  A    A 	  II	  R    R 
// ====================================================== 
// ====================================================== 
//>
// ====================================================== 
//                   BUILD AIRPORT
// ====================================================== 

function CivilAI::Airportz() {
if ((AIAirport.IsValidAirportType(AIAirport.AT_SMALL) || 
	 AIAirport.IsValidAirportType(AIAirport.AT_COMMUTER)) &&
	 (AIGameSettings.IsDisabledVehicleType(AIVehicle.VT_AIR) == false))
	 
	 {
	 CashUp();
	 
local dosh = ((AICompany.GetMaxLoanAmount() - AICompany.GetLoanAmount()) + AICompany.GetBankBalance(Me));
if (dosh > (AIAirport.GetPrice(AIAirport.AT_COMMUTER) * 2)) {	 
AILog.Info("Looking for an airport site...")	


local aplist = AIStationList(AIStation.STATION_AIRPORT); 
local bslist = AIStationList(AIStation.STATION_BUS_STOP); 
local finlist = AIList();
local airdist;

bslist.Valuate(AIStation.GetCargoWaiting, 0); //order by pax waiting
bslist.RemoveBelowValue(250);

foreach (stop,z in bslist) {
if ((AITown.GetAllowedNoise(AIStation.GetNearestTown(stop))) < 4) {
bslist.RemoveItem(stop);		// remove towns with insufficent noise allowance
}
}

// now added in 1.6 - don't build airports too close to all existing airports.

if (aplist.Count() > 0) {
foreach (airport,z in aplist) { // remove stops in serviced towns
foreach (stop,z in bslist) {
if ((AIStation.GetNearestTown(stop)) == (AIStation.GetNearestTown(airport))) {
bslist.RemoveItem(stop);
}
}
}
foreach (airport,z in aplist) { // move stops to the final list if they're far enough away from an existing airport
foreach (stop,z in bslist) {
airdist = AIMap.DistanceManhattan(AIBaseStation.GetLocation(stop),AIBaseStation.GetLocation(airport));
if (airdist > MinAirRange) {
finlist.AddItem(stop,0);
}
}
}
} else { finlist = bslist; }

if (finlist.Count() < 1) {
AILog.Info("I couldn't find one.");
} else {
finlist.Valuate(AIBase.RandItem); // shuffle the list
local newapsite = finlist.Begin();
AILog.Info("attempting to build an airport at " + AIBaseStation.GetName(newapsite) + "."); 


BuildAirport(newapsite,AIBaseStation.GetLocation(newapsite)); // try to build an airport attached to this bus stop

} 
	 } else {
AILog.Info("I can't afford an airport right now.")
}
	 
	 } else {
AILog.Info("I can't build an airport right now.")
}

CashDown;
return
}

// ====================================================== 
//                   SPIRAL AIRPORT
// ====================================================== 
function CivilAI::BuildAirport(station,location) {
// clockwise spiral out
local trytilegrid = [AIMap.GetTileX(location),AIMap.GetTileY(location)]
local trytile;
local x = 0
local y = 0
local i = 0
local s = AIGameSettings.GetValue("station.station_spread")

// commuter

if (AIAirport.IsValidAirportType(AIAirport.AT_COMMUTER)) {

while ((i < s) && !(AIStation.HasStationType(station,AIStation.STATION_AIRPORT))) {
//y--
for (;y >= 0-i;y--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, ".");
if (AITile.IsBuildableRectangle(trytile, 5, 4)) {
BuildComAp(station,trytile);
}
} 
//x--;
for (;x >= 0-i;x--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, ".");
if (AITile.IsBuildableRectangle(trytile, 5, 4)) {
BuildComAp(station,trytile);
}
} 
//y++;
for (;y <= i;y++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, ".");
if (AITile.IsBuildableRectangle(trytile, 5, 4)) {
BuildComAp(station,trytile);
}
} 
//x++;
for (;x <= i;x++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, ".");
if (AITile.IsBuildableRectangle(trytile, 5, 4)) {
BuildComAp(station,trytile);
}
} 
i=i+1
}
if (i == s) {
AILog.Info("I failed to find an airport site at " + AIBaseStation.GetName(station) + "."); 
}
} else if (AIAirport.IsValidAirportType(AIAirport.AT_SMALL)) {

while ((i < s) && !(AIStation.HasStationType(station,AIStation.STATION_AIRPORT))) {
//y--
for (;y >= 0-i;y--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, ".");
if (AITile.IsBuildableRectangle(trytile, 4, 3)) {
BuildSmAp(station,trytile);
}
} 
//x--;
for (;x >= 0-i;x--) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, ".");
if (AITile.IsBuildableRectangle(trytile, 4, 3)) {
BuildSmAp(station,trytile);
}
} 
//y++;
for (;y <= i;y++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, ".");
if (AITile.IsBuildableRectangle(trytile, 4, 3)) {
BuildSmAp(station,trytile);
}
} 
//x++;
for (;x <= i;x++) {
trytile = AIMap.GetTileIndex(trytilegrid[0]+x,trytilegrid[1]+y);
//AISign.BuildSign(trytile, ".");
if (AITile.IsBuildableRectangle(trytile, 4, 3)) {
BuildSmAp(station,trytile);
}
} 
i=i+1
}
if (i == s) {
AILog.Info("I failed to find an airport site at " + AIBaseStation.GetName(station) + "."); 
}
}
}

function CivilAI::BuildComAp(station,location) {

if (AIAirport.BuildAirport(location,AIAirport.AT_COMMUTER,station)) {
AILog.Info("Built a commuter airport.");
AirAssign(station);
return true;
} else if (AIError.GetLastError() == AIError.ERR_FLAT_LAND_REQUIRED) {
AILog.Info("Levelling land..."); 
local endgrid = [AIMap.GetTileX(location),AIMap.GetTileY(location)]
local endtile =  AIMap.GetTileIndex(endgrid[0]+5,endgrid[1]+4);

//AISign.BuildSign(location, "V");
//AISign.BuildSign(endtile, "O");

AITile.LevelTiles(location,endtile);
if (AIAirport.BuildAirport(location,AIAirport.AT_COMMUTER,station)) {
AILog.Info("Built a commuter airport.");
AirAssign(station);
return true;
}
}
}

function CivilAI::BuildSmAp(station,location) {

if (AIAirport.BuildAirport(location,AIAirport.AT_SMALL,station)) {
AILog.Info("Built a small airport.");
AirAssign(station);
return true;
} else if (AIError.GetLastError() == AIError.ERR_FLAT_LAND_REQUIRED) {
AILog.Info("Levelling land..."); 
local endgrid = [AIMap.GetTileX(location),AIMap.GetTileY(location)]
local endtile =  AIMap.GetTileIndex(endgrid[0]+4,endgrid[1]+3);

//AISign.BuildSign(location, "V");
//AISign.BuildSign(endtile, "O");

AITile.LevelTiles(location,endtile);
if (AIAirport.BuildAirport(location,AIAirport.AT_SMALL,station)) {
AILog.Info("Built a small airport.");
AirAssign(station);
return true;
}
}
}

// ====================================================== 
//                   BUILD AIR ROUTES
// ====================================================== 
function CivilAI::AirReview() {

local aplist = AIStationList(AIStation.STATION_AIRPORT);

// remove saturated airports
foreach (airport,z in aplist) { 

local vlist = AIVehicleList_Station(airport)
foreach (veh,z in vlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_AIR) {
vlist.RemoveItem(veh);
}
}

if (((AIAirport.GetAirportType(AIBaseStation.GetLocation(airport)) == AIAirport.AT_SMALL) && vlist.Count() < 4 ) || ((AIAirport.GetAirportType(AIBaseStation.GetLocation(airport)) == AIAirport.AT_COMMUTER) && vlist.Count() < 8 )) {
} else {
aplist.RemoveItem(airport)
}
}

if (aplist.Count() > 1) {

for (local c = 0; c < BuyPlane; c++) {

aplist.Valuate(AIBase.RandItem); // shuffle the airport list
local ap1 = aplist.Begin();
local ap2 = aplist.Next();

local airdist = AIMap.DistanceManhattan(AIBaseStation.GetLocation(ap1),AIBaseStation.GetLocation(ap2));

if (airdist > MinAirRange) {

AILog.Info("Reviewing air service between " + AIBaseStation.GetName(ap1) + " and " + AIBaseStation.GetName(ap2) + " (" + airdist + " tiles)."); 

local paxwait = (AIStation.GetCargoWaiting(ap1,0) + AIStation.GetCargoWaiting(ap2,0))

// select an aircraft

local acmodels = AIEngineList(AIVehicle.VT_AIR);

// remove unsuitables

local ranger = AIOrder.GetOrderDistance(AIVehicle.VT_AIR, AIBaseStation.GetLocation(ap1), AIBaseStation.GetLocation(ap2))

// AILog.Info(paxwait + " passengers waiting, and distance is " + ranger + "."); 

foreach (ac, z in acmodels) {
if ((AIEngine.GetPlaneType(ac) != AIAirport.PT_SMALL_PLANE) && (AIEngine.GetPlaneType(ac) != AIAirport.PT_HELICOPTER)) 
{ 
// AILog.Info("Discarding " + AIEngine.GetName(ac) + " because it is not a small aircraft."); 
acmodels.RemoveItem(ac)
}

if ((AIEngine.GetMaximumOrderDistance(ac) != 0) && (AIEngine.GetMaximumOrderDistance(ac) < ranger))
{ 
// AILog.Info("Discarding " + AIEngine.GetName(ac) + " because it has insufficient range."); 
acmodels.RemoveItem(ac)
}

if (AIEngine.GetCargoType(ac) != 0)
{ 
// AILog.Info("Discarding " + AIEngine.GetName(ac) + " because it doesn't carry Passengers."); 
acmodels.RemoveItem(ac)
}

if (AIEngine.GetCapacity(ac) > (paxwait / 10))
{ 
// AILog.Info("Discarding " + AIEngine.GetName(ac) + " because it is bigger than required."); 
acmodels.RemoveItem(ac)
}

local dosh = ((AICompany.GetMaxLoanAmount() - AICompany.GetLoanAmount()) + AICompany.GetBankBalance(Me));
if (AIEngine.GetPrice(ac) > (dosh * 0.8))
{ 
// AILog.Info("Discarding " + AIEngine.GetName(ac) + " because of insufficient funds."); 
acmodels.RemoveItem(ac)
}


}

local acid= 0;
local blist= 0;
local bcap = 0;
local bdate= 0;
local z = 0;

// now pick one

foreach (ac,z in acmodels) {

//AILog.Info("Assessing " + AIEngine.GetName(ac));

if (AIEngine.IsBuildable(ac))  {

if (AIEngine.GetCapacity(ac) > bcap) {				    // highest capacity.
 acid = ac	
 bcap = AIEngine.GetCapacity(ac)
 bdate =  AIEngine.GetDesignDate(ac)
  } else if ((AIEngine.GetCapacity(ac) == bcap) &&  
		   (AIEngine.GetDesignDate(ac) > bdate))	{	// If a tie, we want the newest.
 acid = ac	
 bcap = AIEngine.GetCapacity(ac)
 bdate =  AIEngine.GetDesignDate(ac)
  }
  }
  }
  
if (acid != 0) {
AILog.Info("I've selected " + AIEngine.GetName(acid)  + " to buy.")

// ============================
// build aircraft and give orders
// ============================
CashUp();

local hangar = AIAirport.GetHangarOfAirport(AIBaseStation.GetLocation(ap1));

// AISign.BuildSign(hangar, "VVV");

local newplane = (AIVehicle.BuildVehicle(hangar,acid));

if (AIVehicle.IsValidVehicle(newplane)) {

// set orders

AIOrder.AppendOrder(newplane, AIBaseStation.GetLocation(ap1),(AIOrder.OF_FULL_LOAD_ANY))
AIOrder.AppendOrder(newplane, AIBaseStation.GetLocation(ap2),(AIOrder.OF_FULL_LOAD_ANY))

// name the plane

// ac names

local tn1 = AITown.GetName(AIStation.GetNearestTown(ap1))
local tn2 = AITown.GetName(AIStation.GetNearestTown(ap2))

local acnames = [
"Spirit of " + tn1,
"Flying " + tn1 + "er",
tn1 + " Adventurer",
tn1 + " Rocket",
tn1 + " Star",
tn1 + " Comet",
tn1 + " Prince",
tn1 + " Princess",
"Queen of " + tn1,
"Pride of " + tn1,
"Duke of " + tn1,
tn1 + " Ambassador",
"Wings over " + tn1,
tn1 + " Flash",
tn1 + " Baby",
tn1 + " Wanderer",
"Spirit of " + tn2,
"Flying " + tn2 + "er",
tn2 + " Adventurer",
tn2 + " Rocket",
tn2 + " Star",
tn2 + " Comet",
tn2 + " Prince",
tn2 + " Princess",
"Queen of " + tn2,
"Pride of " + tn2,
"Duke of " + tn2,
tn2 + " Ambassador",
"Wings over " + tn2,
tn2 + " Flash",
tn2 + " Baby",
tn2 + " Wanderer"
]


local nx = 0
local name = null
local changename = false
while (!changename && (nx < 20)) {
nx++ 
name = (acnames[AIBase.RandRange(32)])
changename = AIVehicle.SetName(newplane,name)
}

// start it up

AILog.Info("I've bought a new plane at " + AIBaseStation.GetName(ap1) + " (" + AIVehicle.GetName(newplane) + ").")
AIVehicle.StartStopVehicle(newplane);
} else {
AILog.Info("For some reason (probably not enough money), I couldn't buy an aircraft at " + AIBaseStation.GetName(ap1) + ".")
}

CashDown();

} else {
AILog.Info("I can't find any aircraft available to buy...")
}
} else {
AILog.Info(AIBaseStation.GetName(ap1) + " and " + AIBaseStation.GetName(ap2) + " are too close together for an air route (" + airdist + " tiles).");
}
}
} else {
AILog.Info("I can't find an air route to review."); 
}

// do we want to remove unprofitable and old aircraft?

local rvlist = AIVehicleList();
foreach (veh,z in rvlist) {
if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_AIR) {
rvlist.RemoveItem(veh);
}
}

for (local v = rvlist.Begin(); !(rvlist.IsEnd()); v = rvlist.Next()) {
if  ((AIVehicle.GetProfitLastYear(v) < 0) &&
	(AIVehicle.GetAge(v) > (365*2))) {
	AIVehicle.SendVehicleToDepot(v);
	AILog.Info(AIVehicle.GetName(v) + " is losing money, so I'm sending it to the hangar.")	
	}
if  (AIVehicle.GetAgeLeft(v) < (365 * 5)) {
	AIVehicle.SendVehicleToDepot(v);
	AILog.Info(AIVehicle.GetName(v) + " is getting old, so I'm sending it to the hangar.")	
	}	
}


}

function CivilAI::AirAssign(station) {

// we just built this airport - reassign aircraft from other airports to fly here.

local aplist = AIStationList(AIStation.STATION_AIRPORT);
local aclist = AIList();
aplist.RemoveItem(station);
aplist.Valuate(AIBase.RandItem); // shuffle the list
local c = 1;
local airdist;
local plane;

// find airports

foreach (airport,z in aplist) {
airdist = AIMap.DistanceManhattan(AIBaseStation.GetLocation(station),AIBaseStation.GetLocation(airport));
if (airdist > MinAirRange) {

// find aircraft
	aclist = AIVehicleList_Station(airport);
			foreach (veh,z in aclist) {
			if (AIVehicle.GetVehicleType(veh) != AIVehicle.VT_AIR) {
			aclist.RemoveItem(veh);
			}	
		}

// send a random aircraft to the new airport			
			
			if (aclist.Count() > 1) { // don't send if we have fewer than 2 aircraft serving this airport
				aclist.Valuate(AIBase.RandItem); // shuffle the list
				plane = aclist.Begin(); 
				AIOrder.RemoveOrder(plane, 1);
				AIOrder.AppendOrder(plane, AIBaseStation.GetLocation(station),(AIOrder.OF_FULL_LOAD_ANY));
				AILog.Info(AIVehicle.GetName(plane) + " has been redirected to the new airport.")	
			c++;
			}

}
if (c > 3) { break }; // break out of the foreach if we have enough aircraft
}



}

 // That's all folks.






